/*
 * Created on 2004. 2. 8.
 *
 */
package controller;

import java.io.IOException;

import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

import model.api.Song;
import controller.player.BasicPlayer;
import controller.player.BasicPlayerListener;

/**
 * @author coms Administrator
 *
 */
public class PlayerController implements BasicPlayerListener {

	private ActionController actionController = null;
	private BasicPlayer theSoundPlayer = null;
	/**
	 * @param controller
	 */
	public PlayerController(ActionController actionController) {
		this.actionController  = actionController;
		theSoundPlayer = new BasicPlayer(this);
	}

	/* (non-Javadoc)
	 * @see controller.player.BasicPlayerListener#updateCursor(int, int)
	 */
	public void updateCursor(int cursor, int total) {
		actionController.updateCursor(cursor,total);
	}

	/* (non-Javadoc)
	 * @see controller.player.BasicPlayerListener#updateMediaData(byte[])
	 */
	public void updateMediaData(byte[] data) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see controller.player.BasicPlayerListener#updateMediaState(java.lang.String)
	 */
	public void updateMediaState(String state) {
		if( state.equals("EOM")){
			actionController.nextSong(null);
		}
	}

	/**
	 * 
	 */
	public void play(Song song) throws PlayerPauseException, PlayerStopException{
		if(theSoundPlayer.getStatus() == BasicPlayer.PAUSED){
			theSoundPlayer.resumePlayback();
			throw new PlayerPauseException(); 
		}else{
			if(theSoundPlayer.getStatus() == BasicPlayer.PLAYING){
				theSoundPlayer.stopPlayback();
			}
			try {
				theSoundPlayer.setDataSource(song.getMusicStream());			
				theSoundPlayer.setTotalLengthInSeconds(song.getTotalTime());				
				theSoundPlayer.startPlayback();	
			} catch (UnsupportedAudioFileException e) {
				theSoundPlayer.stopPlayback();
				e.printStackTrace();
				throw new PlayerStopException(e);
			} catch (LineUnavailableException e) {
				theSoundPlayer.stopPlayback();
				e.printStackTrace();
				throw new PlayerStopException(e);
			} catch (IOException e) {
				theSoundPlayer.stopPlayback();
				e.printStackTrace();
				throw new PlayerStopException(e);
			}
		}	
	}

	/**
	 * 
	 */
	public void Stop() {
		theSoundPlayer.stopPlayback();		
	}

	/**
	 * 
	 */
	public void pause() {
		if (theSoundPlayer.getStatus() == BasicPlayer.PLAYING) {
			theSoundPlayer.pausePlayback();
		}
	}

	/**
	 * @param i
	 * @param j
	 */
	public void setGain(int i, int j) {
		theSoundPlayer.setGain(i,j);
	}

	/**
	 * @return
	 */
	public boolean isPlaying() {
		return theSoundPlayer.getStatus() == BasicPlayer.PLAYING;
	}
}
