package daapLib;


public class DaapContentCode {
    private int dictionary = -1;
    private String contentcodenumber = new String();
    private String contentcodename = new String();
    private int contentcodetype = -1;
    
    public DaapContentCode(byte[] data) {
        DaapParser parser = new DaapParser();
        parser.parse(data);
        
        if (parser.getObjectForKey("mdcl") != null)
            dictionary = ((Integer)parser.getObjectForKey("mdcl")).intValue();
            
        if (parser.getObjectForKey("mcnm") != null)
            contentcodenumber = (String)parser.getObjectForKey("mcnm");
            
        if (parser.getObjectForKey("mcna") != null)
            contentcodename = (String)parser.getObjectForKey("mcna");
        
        if (parser.getObjectForKey("mcty") != null)
            contentcodetype = ((Integer)parser.getObjectForKey("mcty")).intValue();
    }
    
    public DaapContentCode(int dictionary, String contentcodenumber, 
                       String contentcodename, int contentcodetype) {
        this.dictionary = dictionary;
        this.contentcodenumber = contentcodenumber;
        this.contentcodename = contentcodename;
        this.contentcodetype = contentcodetype;
    }
    
    public int getDictionary() {
        return(dictionary);
    }
    
    public String getContentCodeNumber() {
        return(contentcodenumber);
    }
    
    public String getContentCodeName() {
        return(contentcodename);
    }
    
    public int getContentCodeType() {
        return(contentcodetype);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nContentCode");
        buf.append("\ndmap.dictionary=" + dictionary);
        buf.append("\ndmap.contentcodesnumber=" + contentcodenumber);
        buf.append("\ndmap.contentcodesname=" + contentcodename);
        buf.append("\ndmap.contentcodestype=" + contentcodetype);
        return(buf.toString());
    }
}
