package daapLib;


import java.util.ArrayList;

public class DaapContentCodes {
    private int codesresponse = -1;
    private int status = -1;
    ArrayList codes;

    // if we're not getting passed any data, use our own definitions
    public DaapContentCodes() {
        codes = new ArrayList();
        codes.add(new DaapContentCode(41,"miid", "dmap.itemid", 5));
        codes.add(new DaapContentCode(43,"minm", "dmap.itemname", 9));
        codes.add(new DaapContentCode(43,"mikd", "dmap.itemkind", 1));
        codes.add(new DaapContentCode(47,"mper", "dmap.persistentid", 7));
        codes.add(new DaapContentCode(44,"mcon", "dmap.container", 12));
        codes.add(new DaapContentCode(50,"mcti", "dmap.containeritemid", 5));
        codes.add(new DaapContentCode(52,"mpco", "dmap.parentcontainerid", 5));
        codes.add(new DaapContentCode(41,"mstt", "dmap.status", 5));
        codes.add(new DaapContentCode(47,"msts", "dmap.statusstring", 9));
        codes.add(new DaapContentCode(44,"mimc", "dmap.itemcount", 5));
        codes.add(new DaapContentCode(49,"mctc", "dmap.containercount", 5));
        codes.add(new DaapContentCode(48,"mrco", "dmap.returnedcount", 5));
        codes.add(new DaapContentCode(54,"mtco", "dmap.specifiedtotalcount", 5));
        codes.add(new DaapContentCode(42,"mlcl", "dmap.listing", 12));
        codes.add(new DaapContentCode(46,"mlit", "dmap.listingitem", 12));
        codes.add(new DaapContentCode(38,"mbcl", "dmap.bag", 12));
        codes.add(new DaapContentCode(45,"mdcl", "dmap.dictionary", 12));
        codes.add(new DaapContentCode(53,"msrv", "dmap.serverinforesponse", 12));
        codes.add(new DaapContentCode(55,"msau", "dmap.authenticationmethod", 1));
        codes.add(new DaapContentCode(48,"mslr", "dmap.loginrequired", 1));
        codes.add(new DaapContentCode(50,"mpro", "dmap.protocolversion", 11));
        codes.add(new DaapContentCode(53,"msal", "dmap.supportsautologout", 1));
        codes.add(new DaapContentCode(49,"msup", "dmap.supportsupdate", 1));
        codes.add(new DaapContentCode(56,"mspi", "dmap.supportspersistentids", 1));
        codes.add(new DaapContentCode(53,"msex", "dmap.supportsextensions", 1));
        codes.add(new DaapContentCode(49,"msbr", "dmap.supportsbrowse", 1));
        codes.add(new DaapContentCode(48,"msqy", "dmap.supportsquery", 1));
        codes.add(new DaapContentCode(48,"msix", "dmap.supportsindex", 1));
        codes.add(new DaapContentCode(50,"msrs", "dmap.supportsresolve", 1));
        codes.add(new DaapContentCode(50,"mstm", "dmap.timeoutinterval", 5));
        codes.add(new DaapContentCode(49,"msdc", "dmap.databasescount", 5));
        codes.add(new DaapContentCode(48,"mlog", "dmap.loginresponse", 12));
        codes.add(new DaapContentCode(44,"mlid", "dmap.sessionid", 5));
        codes.add(new DaapContentCode(49,"mupd", "dmap.updateresponse", 12));
        codes.add(new DaapContentCode(49,"musr", "dmap.serverrevision", 5));
        codes.add(new DaapContentCode(45,"muty", "dmap.updatetype", 1));
        codes.add(new DaapContentCode(51,"mudl", "dmap.deletedidlisting", 12));
        codes.add(new DaapContentCode(55,"mccr", "dmap.codesresponse", 12));
        codes.add(new DaapContentCode(53,"mcnm", "dmap.codesnumber", 9)); // was 5
        codes.add(new DaapContentCode(51,"mcna", "dmap.codesname", 9));
        codes.add(new DaapContentCode(51,"mcty", "dmap.codestype", 3));
        codes.add(new DaapContentCode(50,"apro", "daap.protocolversion", 11));
        codes.add(new DaapContentCode(50,"avdb", "daap.serverdatabases", 12));
        codes.add(new DaapContentCode(49,"abro", "daap.databasebrowse", 12));
        codes.add(new DaapContentCode(53,"abal", "daap.browsealbumlisting", 12));
        codes.add(new DaapContentCode(54,"abar", "daap.browseartistlisting", 12));
        codes.add(new DaapContentCode(56,"abcp", "daap.browsecomposerlisting", 12));
        codes.add(new DaapContentCode(53,"abgn", "daap.browsegenrelisting", 12));
        codes.add(new DaapContentCode(48,"adbs", "daap.databasesongs", 12));
        codes.add(new DaapContentCode(44,"asal", "daap.songalbum", 9));
        codes.add(new DaapContentCode(45,"asar", "daap.songartist", 9));
        codes.add(new DaapContentCode(53,"asbt", "daap.songbeatsperminute", 3));
        codes.add(new DaapContentCode(46,"asbr", "daap.songbitrate", 3));
        codes.add(new DaapContentCode(46,"ascm", "daap.songcomment", 9));
        codes.add(new DaapContentCode(50,"asco", "daap.songcompilation", 1));
        codes.add(new DaapContentCode(47,"ascp", "daap.songcomposer", 9));
        codes.add(new DaapContentCode(48,"asda", "daap.songdateadded", 10));
        codes.add(new DaapContentCode(51,"asdm", "daap.songdatemodified", 10));
        codes.add(new DaapContentCode(48,"asdc", "daap.songdisccount", 3));
        codes.add(new DaapContentCode(49,"asdn", "daap.songdiscnumber", 3));
        codes.add(new DaapContentCode(47,"asdb", "daap.songdisabled", 1));
        codes.add(new DaapContentCode(47,"aseq", "daap.songeqpreset", 9));
        codes.add(new DaapContentCode(45,"asfm", "daap.songformat", 9));
        codes.add(new DaapContentCode(44,"asgn", "daap.songgenre", 9));
        codes.add(new DaapContentCode(50,"asdt", "daap.songdescription", 9));
        codes.add(new DaapContentCode(53,"asrv", "daap.songrelativevolume", 1));
        codes.add(new DaapContentCode(49,"assr", "daap.songsamplerate", 5));
        codes.add(new DaapContentCode(43,"assz", "daap.songsize", 5));
        codes.add(new DaapContentCode(48,"asst", "daap.songstarttime", 5));
        codes.add(new DaapContentCode(47,"assp", "daap.songstoptime", 5));
        codes.add(new DaapContentCode(43,"astm", "daap.songtime", 5));
        codes.add(new DaapContentCode(49,"astc", "daap.songtrackcount", 3));
        codes.add(new DaapContentCode(50,"astn", "daap.songtracknumber", 3));
        codes.add(new DaapContentCode(49,"asur", "daap.songuserrating", 1));
        codes.add(new DaapContentCode(43,"asyr", "daap.songyear", 3));
        codes.add(new DaapContentCode(47,"asdk", "daap.songdatakind", 1));
        codes.add(new DaapContentCode(46,"asul", "daap.songdataurl", 9));
        codes.add(new DaapContentCode(52,"aply", "daap.databaseplaylists", 12));
        codes.add(new DaapContentCode(47,"abpl", "daap.baseplaylist", 1));
        codes.add(new DaapContentCode(48,"apso", "daap.playlistsongs", 12));
        codes.add(new DaapContentCode(42,"arsv", "daap.resolve", 12));
        codes.add(new DaapContentCode(46,"arif", "daap.resolveinfo", 12));
        codes.add(new DaapContentCode(58,"aeSP", "com.apple.itunes.smart-playlist", 1));
        codes.add(new DaapContentCode(58,"aeNV", "com.apple.itunes.norm-volume", 5));
    }

    public DaapContentCodes(byte[] data) {
        int startOfDictionary = 0;
        while (startOfDictionary < data.length) {
            if (data[startOfDictionary] == 'm' && data[startOfDictionary+1] == 'd' &&
                data[startOfDictionary+2] == 'c' && data[startOfDictionary+3] == 'l') {
                
                break;
            } else {
                startOfDictionary++;
            }
        }
        
        byte[] headerData = new byte[startOfDictionary];
        System.arraycopy(data, 0, headerData, 0, startOfDictionary);
        DaapParser parser = new DaapParser();
        parser.parse(headerData);
        
        if (parser.getObjectForKey("mccr") != null)
            codesresponse = ((Integer)parser.getObjectForKey("mccr")).intValue();
        if (parser.getObjectForKey("mstt") != null)
            status = ((Integer)parser.getObjectForKey("mstt")).intValue();
        
        codes = new ArrayList();
        
        int endOfDictionary = startOfDictionary + 1;
        while (endOfDictionary < data.length) {
            if (data[endOfDictionary] == 'm' && data[endOfDictionary+1] == 'd' &&
                data[endOfDictionary+2] == 'c' && data[endOfDictionary+3] == 'l') {
                
                int payloadLength = endOfDictionary - startOfDictionary;
                byte[] codeData = new byte[payloadLength];
                System.arraycopy(data, startOfDictionary, codeData, 0, payloadLength);
                DaapContentCode code = new DaapContentCode(codeData);
                codes.add(code);
                startOfDictionary = endOfDictionary;
                endOfDictionary += 4;
            }
            endOfDictionary++;
        }
    }
    
    public int getContentCodesResponse() {
        return(codesresponse);
    }
    
    public int getStatus() {
        return(status);
    }
    
    public int getContentCodeTypeFor(String tag) {
        for (int i=0; i<codes.size(); i++) {
            DaapContentCode code = (DaapContentCode)codes.get(i);
            if (code.getContentCodeNumber().equals(tag))
                return(code.getContentCodeType());
        }
        return(-1);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nContentCodes");
        buf.append("\ndmap.contentcodesresponse=" + codesresponse);
        buf.append("\ndmap.status=" + status);
        return(buf.toString());
    }
}
