package daapLib;


public class DaapDatabasesResponse {
    private int serverdatabases = -1;
    private int status = -1;
    private int updatetype = -1;
    private int specifiedtotalcount = -1;
    private int returnedcount = -1;
    private int listing = -1;
    private int listingitem = -1;
    private int itemid = -1;
    private String persistentid = new String();
    private String itemname = new String();
    private int itemcount = -1;
    private int containercount = -1;
    
    public DaapDatabasesResponse(byte[] data) {
        DaapParser parser = new DaapParser();
        parser.parse(data);
        
        if (parser.getObjectForKey("avdb") != null)
        serverdatabases = ((Integer)parser.getObjectForKey("avdb")).intValue(); 

        if (parser.getObjectForKey("mstt") != null)
            status = ((Integer)parser.getObjectForKey("mstt")).intValue();

        if (parser.getObjectForKey("muty") != null)
            updatetype = ((Integer)parser.getObjectForKey("muty")).intValue();

        if (parser.getObjectForKey("mtco") != null)
            specifiedtotalcount = ((Integer)parser.getObjectForKey("mtco")).intValue();

        if (parser.getObjectForKey("mrco") != null)
            returnedcount = ((Integer)parser.getObjectForKey("mrco")).intValue();

        if (parser.getObjectForKey("mlcl") != null)
            listing = ((Integer)parser.getObjectForKey("mlcl")).intValue();

        if (parser.getObjectForKey("mlit") != null)
            listingitem = ((Integer)parser.getObjectForKey("mlit")).intValue();

        if (parser.getObjectForKey("miid") != null)
            itemid = ((Integer)parser.getObjectForKey("miid")).intValue();

        if (parser.getObjectForKey("mper") != null)
            persistentid = (String)parser.getObjectForKey("mper");

        if (parser.getObjectForKey("minm") != null)
            itemname = (String)parser.getObjectForKey("minm");

        if (parser.getObjectForKey("mimc") != null)
            itemcount = ((Integer)parser.getObjectForKey("mimc")).intValue();

        if (parser.getObjectForKey("mctc") != null)
            containercount = ((Integer)parser.getObjectForKey("mctc")).intValue();
    }
    
    public int getServerDatabases() {
        return(serverdatabases);
    }
    
    public int getStatus() {
        return(status);
    }
    
    public int getSpecifiedTotalCount() {
        return(specifiedtotalcount);
    }
    
    public int getReturnedCount() {
        return(returnedcount);
    }
    
    public int getListing() {
        return(listing);
    }
    
    public int getListingItem() {
        return(listingitem);
    }
    
    public int getItemID() {
        return(itemid);
    }
    
    public String getPersistentID() {
        return(persistentid);
    }
    
    public String getItemName() {
        return(itemname);
    }
    
    public int getItemCount() {
        return(itemcount);
    }
    
    public int getContainerCount() {
        return(containercount);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nDatabasesResponse");
        buf.append("\ndaap.serverdatabases=" + serverdatabases);
        buf.append("\ndmap.status=" + status);
        buf.append("\ndmap.updatetype=" + updatetype);
        buf.append("\ndmap.specifiedtotalcount=" + specifiedtotalcount);
        buf.append("\ndmap.returnedcount=" + returnedcount);
        buf.append("\ndmap.listing=" + listing);
        buf.append("\ndmap.listingitem=" + listingitem);
        buf.append("\ndmap.itemid=" + itemid);
        buf.append("\ndmap.persistentid=" + persistentid);
        buf.append("\ndmap.itemname=" + itemname);
        buf.append("\ndmap.itemcount=" + itemcount);
        buf.append("\ndmap.containercount=" + containercount);
        return(buf.toString());
    }
}
