package daapLib;

import java.util.Enumeration;

import javax.swing.tree.TreeNode;

import daapLib.api.DaapRemotePlaylist;
import daapLib.api.DaapRemoteSong;
import daapLib.api.DaapRemoteSongs;

public class DaapPlaylist implements DaapRemotePlaylist{
    private int listingitem = -1;
    private int itemid = -1;
    private String persistentid = new String();
    private String itemname = new String();
    private boolean smartplaylist = false;
    private int itemcount = -1;
    private TreeNode parent = null;



    public DaapPlaylist(byte[] data, DaapShared parent) {
        this.parent = parent;
        DaapParser parser = new DaapParser();
        parser.parse(data);
        
        if (parser.getObjectForKey("mlit") != null)
            listingitem = ((Integer)parser.getObjectForKey("mlit")).intValue();
        if (parser.getObjectForKey("miid") != null)
            itemid = ((Integer)parser.getObjectForKey("miid")).intValue();
        if (parser.getObjectForKey("mper") != null)
            persistentid = (String)parser.getObjectForKey("mper");
        if (parser.getObjectForKey("minm") != null)
            itemname = (String)parser.getObjectForKey("minm");
        if (parser.getObjectForKey("aeSP") != null)
            smartplaylist = true;
        if (parser.getObjectForKey("mimc") != null)
            itemcount = ((Integer)parser.getObjectForKey("mimc")).intValue();
    }
    
    public int getListingItem() {
        return(listingitem);
    }
    
    public int getItemID() {
        return(itemid);
    }
    
    public String getPersistentID() {
        return(persistentid);
    }
    
    public String getItemName() {
        return(itemname);
    }
    
    public boolean isSmartPlaylist() {
        return(smartplaylist);
    }
    
    public int getItemCount() {
        return(itemcount);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nPlaylist");
        buf.append("\ndmap.listingitem=" + listingitem);
        buf.append("\ndmap.itemid=" + itemid);
        buf.append("\ndmap.persistentid=" + persistentid);
        buf.append("\ndmap.itemname=" + itemname);
        buf.append("\ncom.apple.itunes.smart-playlist=" + smartplaylist);
        buf.append("\ndmap.itemcount=" + itemcount);
        return(buf.toString());
    }

    public TreeNode getChildAt(int i) {
        return null;
    }

    public int getChildCount() {
        return 0;
    }

    public TreeNode getParent() {
        return parent;
    }
	public void setParent(TreeNode parent){
		this.parent = parent;
    }
    public int getIndex(TreeNode node) {
        return -1;
    }

    public boolean getAllowsChildren() {
        return false;
    }

    public boolean isLeaf() {
        return true;
    }

    public Enumeration children() {
        return null;
    }

    public DaapRemoteSongs getSongs(){
        if(parent instanceof DaapShared){
            DaapShared sDaap = (DaapShared)parent;
            int index = sDaap.getDaapServer().getPlaylists().getIndex(this);
            DaapSongs songs = sDaap.getDaapServer().getPlaylistSongs(index);
            DaapRemoteSong s;
            for(int i=0; i<songs.count(); i++){
            	s = (DaapRemoteSong)songs.getSongList().get(i);
            	songs.getSongList().set(i, sDaap.getSongById(s.getItemID()));
            }
            return songs;
    	}
        return null;
    }
	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Playlist#getViewOptions()
	 */
	public int getViewOptions() {
		return DaapShared.viewOptions;
	}

	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Playlist#setViewOptions(int)
	 */
	public void setViewOptions(int options) {
		DaapShared.viewOptions=options;
	}

}
