package daapLib;


public class DaapServerInfoResponse {
    private int serverinforesponse = -1;
    private int status = -1;
    private String dmapProtocolVersion = new String();
    private String daapProtocolVersion = new String();
    private int timeoutinterval = -1;
    private int authenticationmethod = -1;
    private int databasescount = -1;
    private boolean loginrequired=false;
    private boolean autologout=false;
    private boolean update=false;
    private boolean persistentids=false;
    private boolean extensions=false;
    private boolean browse=false;
    private boolean query=false;
    private boolean index=false;
    private boolean resolve=false;
    private String itemname = new String();
    
    public DaapServerInfoResponse(byte[] data) {
        DaapParser parser = new DaapParser();
        parser.parse(data);
        
        if (parser.getObjectForKey("msrv") != null)
            serverinforesponse = ((Integer)parser.getObjectForKey("msrv")).intValue();
        
        if (parser.getObjectForKey("mstt") != null)
            status = ((Integer)parser.getObjectForKey("mstt")).intValue();
        
        if (parser.getObjectForKey("mpro") != null)
            dmapProtocolVersion = (String)parser.getObjectForKey("mpro");
        
        if (parser.getObjectForKey("apro") != null)
            daapProtocolVersion = (String)parser.getObjectForKey("apro");

        if (parser.getObjectForKey("minm") != null)
            itemname = (String)parser.getObjectForKey("minm");
        
        if (parser.getObjectForKey("mstm") != null)
            timeoutinterval = ((Integer)parser.getObjectForKey("mstm")).intValue();
        
        if (parser.getObjectForKey("msdc") != null)
            databasescount = ((Integer)parser.getObjectForKey("msdc")).intValue();

        if (parser.getObjectForKey("msau") != null)
            authenticationmethod = ((Integer)parser.getObjectForKey("msau")).intValue();

        if (parser.getObjectForKey("mslr") != null)
            loginrequired = true;

        if (parser.getObjectForKey("msal") != null)
            autologout = true;

        if (parser.getObjectForKey("msup") != null)
            update = true;
            
        if (parser.getObjectForKey("mspi") != null)
            persistentids = true;
            
        if (parser.getObjectForKey("msex") != null)
            extensions = true;
            
        if (parser.getObjectForKey("msbr") != null)
            browse = true;

        if (parser.getObjectForKey("msqy") != null)
            query = true;

        if (parser.getObjectForKey("msix") != null)
            index = true;

        if (parser.getObjectForKey("msrs") != null)
            resolve = true;
    }
    
    public int getServerInfoResponse() {
        return(serverinforesponse);
    }
    
    public int getStatus() {
        return(status);
    }
    
    public String getDMAPProtocolVersion() {
        return(dmapProtocolVersion);
    }
    
    public String getDAAPProtocolVersion() {
        return(daapProtocolVersion);
    }
    
    public String getItemName() {
        return(itemname);
    }
    
    public boolean loginrequired() {
        return(loginrequired);
    }
    
    public int getTimeoutInterval() {
        return(timeoutinterval);
    }
    
    public int getAuthenticationMethod() {
        return(authenticationmethod);
    }
    
    public boolean supportsAutologout() {
        return(autologout);
    }
    
    public boolean supportsUpdate() {
        return(update);
    }
    
    public boolean supportsPersistentIDs() {
        return(persistentids);
    }
    
    public boolean supportsExtensions() {
        return(extensions);
    }
    
    public boolean supportsBrowse() {
        return(browse);
    }
    
    public boolean supportsQuery() {
        return(query);
    }
    
    public boolean supportsIndex() {
        return(index);
    }
    
    public boolean supportsResolve() {
        return(resolve);
    }
    
    public int getDatabasesCount() {
        return(databasescount);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nServerInfoResponse");
        buf.append("\ndmap.serverinforesponse=" + serverinforesponse);
        buf.append("\ndmap.status=" + status);
        buf.append("\ndmap.protocolversion=" + dmapProtocolVersion);
        buf.append("\ndaap.protocolversion=" + daapProtocolVersion);
        buf.append("\ndmap.itemname=" + itemname);
        buf.append("\ndmap.loginrequired=" + loginrequired);
        buf.append("\ndmap.timeoutinterval=" + timeoutinterval);
        buf.append("\ndmap.supportesautologout=" + autologout);
        buf.append("\ndmap.authenticationmethod=" + authenticationmethod);
        buf.append("\ndmap.supportsupdate=" + update);
        buf.append("\ndmap.supportspersistentids=" + persistentids);
        buf.append("\ndmap.supportsextensions=" + extensions);
        buf.append("\ndmap.supportsbrowse=" + browse);
        buf.append("\ndmap.supportsquery=" + query);
        buf.append("\ndmap.supportsindex=" + index);
        buf.append("\ndmap.supportsresolve=" + resolve);
        buf.append("\ndmap.databasescount=" + databasescount);
        return(buf.toString());
    }
}
