package daapLib;

import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JOptionPane;
import javax.swing.tree.TreeNode;

import daapLib.api.DaapRemoteSong;
import daapLib.api.DaapRemoteSongs;
import daapLib.api.MasterPlaylist;


public class DaapShared extends Thread implements MasterPlaylist{

    private String sharedName = null;
    private String hostName = null;
    private String password = "";
    private DaapServer server = null;
    private TreeNode parent = null;
    
	public static int viewOptions = 7;


    public DaapShared(String sharedName, String hostName, TreeNode parent){
		this.sharedName = sharedName;
        this.hostName = hostName;
        this.parent = parent;
    }

    public void setPassword(String password){
        this.password = password;
    }

//	public void setStatusMsg(String status){
//        StatusComponent.getInstance().setText(status);
//    }


    public DaapServer getDaapServer(){
		return this.server;
    }

    public TreeNode getChildAt(int i) {
        if(server!=null){
            return server.getPlaylists().getChildAt(i+1);
        }
        else return null;
    }

    public int getChildCount() {
        if(server!=null){
            return server.getPlaylists().getChildCount()-1;
        }
        return 0;
    }

    public TreeNode getParent() {
		System.out.println("will be null "+parent);
    	if(parent!=null&&parent.getChildCount()==1){
    		return parent.getParent();
    	}
    	else{
        	return parent;
    	}
    }

    public int getIndex(TreeNode node) {
        if(server!=null){
            return server.getPlaylists().getIndex(node);
        }
        return -1;
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return server==null;
    }

    public Enumeration children() {
        if(server==null){
            return new Vector().elements();
        }else{
            return server.getPlaylists().children();
        }
    }

    public int connect(java.awt.Component comp){
        if(server!=null){
            if(server.getHostname()==hostName){
                return 2;
            }else{
        	    server.logoff();
            }
        }
        server = new DaapServer(hostName, password, this);
        server.start();
        while(server.isCompleted()==false){
            try {
                Thread.sleep((int)(Math.random()*100));
            }
            catch ( Exception e ) {
            	e.printStackTrace();
            }
        }
        if(server.didErrorOccur()){
            if(server.getHttpStatus()==java.net.HttpURLConnection.HTTP_UNAUTHORIZED){
                String pass = JOptionPane.showInputDialog(comp,"wrong password", "wrong password",JOptionPane.OK_CANCEL_OPTION);
				if(pass==null) return -1;
                else{
					password=pass;
                    server = null;
                    return 0;
                }
            }else return -2;
        }else return 1;
    }

    public boolean isSmartPlaylist() {
        return false;
    }

    public String getItemName() {
        return this.sharedName;
    }

    public DaapRemoteSongs getSongs() {
        if(server !=null) {
        	//return server.getPlaylistSongs(0);
            return server.getSongs();
        }
        return null;
    }
	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Playlist#getViewOptions()
	 */
	public int getViewOptions() {
		return viewOptions;
	}

	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Playlist#setViewOptions(int)
	 */
	public void setViewOptions(int options) {
		viewOptions = options;
	}


	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.MasterPlaylist#getSongById(int)
	 */
	public DaapRemoteSong getSongById(int id) {
		if(server!=null){
			return server.getSongById(id);
		}
		return null;
	}
}
