package daapLib;

import java.io.InputStream;
import java.math.BigDecimal;

import daapLib.api.DaapRemoteSong;


public class DaapSong implements DaapRemoteSong{
	
	private boolean playing = false;
    private int listing = -1;
    private int itemkind = -1;
    private String album = new String();
    private String artist = new String();
    private int bitrate = -1;
    private int compilation = -1;
    private String composer = new String();
    private String dateadded = new String();
    private String datemodified = new String();
    private int disccount = -1;
    private int discnumber = -1;
    private int datakind = -1;
    private int beatsperminute = -1;
    private String format = new String();
    private String genre = new String();
    private String comment = new String();
    private int itemid = -1;
    private String description = new String();
    private String itemname = new String();
    private String persistentid = new String();
    private int disabled = -1;
    private int samplerate = -1;
    private int size = -1;
    private int time = -1;
    private int trackcount = -1;
    private int tracknumber = -1;
    private int userrating = -1;
    private int year = -1;
    private DaapServer server = null;

    
    public DaapSong(byte[] data, DaapServer server) {
        this.server = server;
        DaapParser parser = new DaapParser();
        parser.parse(data);
        
        if (parser.getObjectForKey("mlcl") != null)
            listing = ((Integer)parser.getObjectForKey("mlcl")).intValue();
        
        if (parser.getObjectForKey("mikd") != null)
            itemkind = ((Integer)parser.getObjectForKey("mikd")).intValue();
        
        if (parser.getObjectForKey("asal") != null)
            album = (String)parser.getObjectForKey("asal");
        
        if (parser.getObjectForKey("asar") != null)
            artist = (String)parser.getObjectForKey("asar");
        
        if (parser.getObjectForKey("asbr") != null)
            bitrate = ((Integer)parser.getObjectForKey("asbr")).intValue();
        
        if (parser.getObjectForKey("asco") != null)
            compilation = ((Integer)parser.getObjectForKey("asco")).intValue();
        
        if (parser.getObjectForKey("asda") != null)
            dateadded = (String)parser.getObjectForKey("asda");
        
        if (parser.getObjectForKey("asdm") != null)
            datemodified = (String)parser.getObjectForKey("asdm");
        
        if (parser.getObjectForKey("ascp") != null)
            composer = (String)parser.getObjectForKey("ascp");
        
        if (parser.getObjectForKey("asdc") != null)
            disccount = ((Integer)parser.getObjectForKey("asdc")).intValue();
        
        if (parser.getObjectForKey("asdn") != null)
            discnumber = ((Integer)parser.getObjectForKey("asdn")).intValue();
        
        if (parser.getObjectForKey("asdk") != null)
            datakind = ((Integer)parser.getObjectForKey("asdk")).intValue();
        
        if (parser.getObjectForKey("asfm") != null)
            format = (String)parser.getObjectForKey("asfm");
        
        if (parser.getObjectForKey("asgn") != null)
            genre = (String)parser.getObjectForKey("asgn");
        
        if (parser.getObjectForKey("miid") != null)
            itemid = ((Integer)parser.getObjectForKey("miid")).intValue();
        
        if (parser.getObjectForKey("asdt") != null)
            description = (String)parser.getObjectForKey("asdt");
        
        if (parser.getObjectForKey("minm") != null)
            itemname = (String)parser.getObjectForKey("minm");
        
        if (parser.getObjectForKey("mper") != null)
            persistentid = (String)parser.getObjectForKey("mper");
        
        if (parser.getObjectForKey("asdb") != null)
            disabled = ((Integer)parser.getObjectForKey("asdb")).intValue();
        
        if (parser.getObjectForKey("assr") != null)
            samplerate = ((Integer)parser.getObjectForKey("assr")).intValue();
        
        if (parser.getObjectForKey("assz") != null)
            size = ((Integer)parser.getObjectForKey("assz")).intValue();
        
        if (parser.getObjectForKey("astm") != null)
            time = ((Integer)parser.getObjectForKey("astm")).intValue();
        
        if (parser.getObjectForKey("astc") != null)
            trackcount = ((Integer)parser.getObjectForKey("astc")).intValue();
        
        if (parser.getObjectForKey("astn") != null)
            tracknumber = ((Integer)parser.getObjectForKey("astn")).intValue();
        
        if (parser.getObjectForKey("asur") != null)
            userrating = ((Integer)parser.getObjectForKey("asur")).intValue();
        
        if (parser.getObjectForKey("asyr") != null)
            year = ((Integer)parser.getObjectForKey("asyr")).intValue();
        
        if (parser.getObjectForKey("asbt") != null)
            beatsperminute = ((Integer)parser.getObjectForKey("asbt")).intValue();
        
        if (parser.getObjectForKey("asbr") != null)
            bitrate = ((Integer)parser.getObjectForKey("asbr")).intValue();

        if (parser.getObjectForKey("ascm") != null)
            comment = (String)parser.getObjectForKey("ascm");
    }
    
    public int getListing() {
        return(listing);
    }
    
    public int getItemKind() {
        return(itemkind);
    }
    
    public String getAlbum() {
        return(album);
    }
    
    public String getArtist() {
        return(artist);
    }
    
    public int getBitrate() {
        return(bitrate); 
    }
    
    public int getCompilation() {
        return(compilation);
    }
    
    public String getComposer() {
        return(composer);
    }
    
    public int getDiscCount() {
        return(disccount);
    }
    
    public int getDiscNumber() {
        return(discnumber);
    }
    
    public int getDataKind() {
        return(datakind);
    }
    
    public String getFormat() {
        return(format);
    }
    
    public String getGenre() {
        return(genre);
    }
    
    public int getItemID() {
        return(itemid);
    }
    
    public String getDescription() {
        return(description);
    }
    
    public String getItemName() {
        return(itemname);
    }
    
    public String getPersistentID() {
        return(persistentid);
    }
    
    public int getDisabled() {
        return(disabled);
    }
    
    public int getSampleRate() {
        return(samplerate);
    }
    
    public int getSize() {
        return(size);
    }
    
    public int getTime() {
        return(time);
    }
    
    public int getTrackCount() {
        return(trackcount);
    }
    
    public int getTrackNumber() {
        return(tracknumber);
    }
    
    public int getUserRating() {
        return(userrating);
    }
    
    public int getYear() {
        return(year);
    }
    
    public int getBeatsPerMinute() {
        return(beatsperminute);
    }
    
    public int getBitRate() {
        return(bitrate);
    }
    
    public String getDateAdded() {
        return(dateadded);
    }
    
    public String getDateModified() {
        return(datemodified);
    }
    
    public String getComment() {
        return(comment);
    }
    
    public String getTrackNumberAsString() {
        if (tracknumber == -1 || tracknumber == 0)
            return null;
        if (trackcount != -1 && trackcount != 0)
            return(tracknumber + " of " + trackcount);
        return("" + tracknumber);
    }
    
    public String getDiscNumberAsString() {
        if (discnumber == -1 || discnumber == 0)
            return null;
        if (disccount != -1 && disccount != 0)
            return(discnumber + " of " + disccount);
        return("" + discnumber);
    }
    
    public String getUserRatingAsString() {
        if (userrating == -1 || userrating == 0)
            return null;
        return((userrating/20) + "/5");
    }
    
    public String getTimeAsString() {
        int totalseconds = time/1000;
        int minutes = totalseconds/60;
        int seconds = totalseconds - (minutes*60);
        if (seconds < 10)
            return(minutes + ":0" + seconds);
        return(minutes + ":" + seconds);
    }
    
    public String getValueForIdentifier(String identifier) {
        if (identifier.equals("name")) {
            return(itemname);
        } else if (identifier.equals("time")) {
            return(getTimeAsString());
        } else if (identifier.equals("artist")) {
            return(artist);
        } else if (identifier.equals("album")) {
            return(album);
        } else if (identifier.equals("genre")) {
            return(genre);
        } else if (identifier.equals("rating")) {
            return(getUserRatingAsString());
        } else if (identifier.equals("bpm")) {
            if (beatsperminute == 0)
                return(null);
            return("" + beatsperminute);
        } else if (identifier.equals("comment")) {
            return(comment);
        } else if (identifier.equals("composer")) {
            return(composer);
        } else if (identifier.equals("dateadded")) {
            return(dateadded);
        } else if (identifier.equals("datemodified")) {
            return(datemodified);
        } else if (identifier.equals("discnumber")) {
            return(getDiscNumberAsString());
        } else if (identifier.equals("kind")) {
            return(description);
        } else if (identifier.equals("bitrate")) {
            return(bitrate + " kbps");
        } else if (identifier.equals("samplerate")) {
            return(samplerate + " Hz");
        } else if (identifier.equals("size")) {
            BigDecimal filesize = new BigDecimal(size);
            BigDecimal megabyte = new BigDecimal(1024*1024);
            float returnValue = filesize.divide(megabyte, 2, BigDecimal.ROUND_UP).floatValue();
            if (returnValue > 1)
                return(returnValue + " MB");
            BigDecimal kilobyte = new BigDecimal(1024);
            returnValue = filesize.divide(kilobyte, 2, BigDecimal.ROUND_UP).floatValue();
            return(returnValue + " KB");
        } else if (identifier.equals("tracknumber")) {
            return(getTrackNumberAsString());
        } else if (identifier.equals("year")) {
            if (year == 0)
                return(null);
            return("" + year);
        }
        return(null);
    }
    
    public boolean contains(String text) {
        if (itemname.toLowerCase().indexOf(text) != -1)
            return true;
        if (artist.toLowerCase().indexOf(text) != -1)
            return true;
        if (album.toLowerCase().indexOf(text) != -1)
            return true;
        return false;
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nSong");
        buf.append("\ndmap.listingitem=" + listing);
        buf.append("\ndmap.itemkind=" + itemkind);
        buf.append("\ndaap.songalbum=" + album);
        buf.append("\ndaap.songartist=" + artist);
        buf.append("\ndaap.songbitrate=" + bitrate);
        buf.append("\ndaap.songcompilation=" + compilation);
        buf.append("\ndaap.songcomposer=" + composer);
        buf.append("\ndaap.songdateadded=" + dateadded);
        buf.append("\ndaap.songdatemodified=" + datemodified);
        buf.append("\ndaap.songdisccount=" + disccount);
        buf.append("\ndaap.songdiscnumber=" + discnumber);
        buf.append("\ndaap.songdatakind=" + datakind);
        buf.append("\ndaap.songformat=" + format);
        buf.append("\ndaap.songgenre=" + genre);
        buf.append("\ndmap.itemid=" + itemid);
        buf.append("\ndaap.songdescription=" + description);
        buf.append("\ndmap.itemname=" + itemname);
        buf.append("\ndmap.persistentid=" + persistentid);
        buf.append("\ndaap.songdisabled=" + disabled);
        buf.append("\ndaap.songsamplerate=" + samplerate);
        buf.append("\ndaap.songsize=" + size);
        buf.append("\ndaap.songtime=" + time);
        buf.append("\ndaap.songtrackcount=" + trackcount);
        buf.append("\ndaap.songtracknumber=" + tracknumber);
        buf.append("\ndaap.songuserrating=" + userrating);
        buf.append("\ndaap.songyear=" + year);
        return(buf.toString());
    }

    public InputStream getStream() {
        return server.getSongThread(this).getStream();
    }
	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Song#isPlaying()
	 */
	public boolean isPlaying() {
		return playing;
	}

	/* (non-Javadoc)
	 * @see ch.toenz.jTunes.Song#setPlaying(boolean)
	 */
	public void setPlaying(boolean playing) {
		this.playing = playing;
	}

}
