package daapLib;

public class DaapUpdateResponse {
    private int updateresponse = -1;
    private int status = -1;
    private int serverrevision = -1;
    
    public DaapUpdateResponse(byte[] data) {
        DaapParser parser = new DaapParser();
        parser.parse(data);

        if (parser.getObjectForKey("mlog") != null)
            updateresponse = ((Integer)parser.getObjectForKey("mlog")).intValue(); 

        if (parser.getObjectForKey("mstt") != null)
            status = ((Integer)parser.getObjectForKey("mstt")).intValue();

        if (parser.getObjectForKey("musr") != null)
            serverrevision = ((Integer)parser.getObjectForKey("musr")).intValue(); 
    }
    
    public int getUpdateResponse() {
        return(updateresponse);
    }
    
    public int getStatus() {
        return(status);
    }
    
    public int getServerRevision() {
        return(serverrevision);
    }
    
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("\nUpdateResponse");
        buf.append("\ndmap.updateresponse=" + updateresponse);
        buf.append("\ndmap.status=" + status);
        buf.append("\ndmap.serverrevision=" + serverrevision);
        return(buf.toString());
    }
}
