package daapLib.network;

public class NetworkSpeedCalculator {
	int filesize;
	int amountRead;
	int lastRead;
	int lastTime;
	int currentTime;
	int kbPerSec;
	int lastkbPerSec;

	public NetworkSpeedCalculator() {
		resetValues();
	}

	public void resetValues() {
		filesize = 0;
		amountRead = 0;
		lastRead = 0;
		lastTime = 0;
		currentTime = 0;
		kbPerSec = 0;
		lastkbPerSec = 0;
	}

	public void setFilesize(int filesize) {
		resetValues();
		this.filesize = filesize;
	}

	public void setAmountRead(int amountRead) {
		lastRead = this.amountRead;
		this.amountRead = amountRead;
		lastTime = currentTime;
		currentTime = (int) System.currentTimeMillis() / 1000;
		update();
	}

	public int getFilesize() {
		return filesize;
	}

	public int getAmountRead() {
		return amountRead;
	}

	public void update() {
		int sizeDifference = amountRead - lastRead;
		int secondsElapsed = currentTime - lastTime;
		kbPerSec = 0;
		if (sizeDifference != 0 && secondsElapsed != 0) {
			kbPerSec = (sizeDifference / secondsElapsed) / 1024;
		} else {
			kbPerSec = lastkbPerSec;
		}

		kbPerSec = (kbPerSec + lastkbPerSec) / 2;
		lastkbPerSec = kbPerSec;
	}

	public int getKilobytesPerSecondAsNumber() {
		return (kbPerSec);
	}

	public String getKilobytesPerSecondAsString() {
		return (
			(int) (amountRead / 1024)
				+ " of "
				+ (int) (filesize / 1024)
				+ "KB ("
				+ kbPerSec
				+ "KB/sec)");
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("\nNetworkSpeedCalculator");
		buf.append("\nfilesize=" + filesize);
		buf.append("\namountRead=" + amountRead);
		buf.append("\nlastRead=" + lastRead);
		buf.append("\nlastTime=" + lastTime);
		buf.append("\ncurrentTime=" + currentTime);
		buf.append("\nkbPerSec=" + kbPerSec);
		buf.append("\nlastkbPerSec=" + lastkbPerSec);
		return (buf.toString());
	}
}
