/*
 * Created on 2004. 1. 27.
 *
 */
package gui;

import java.awt.Font;

import javax.swing.ActionMap;
import javax.swing.JPanel;

import laf.mac.MacLafFactory;

/**
 * @author hyoki
 *
 */
public class ButtonsPanel extends JPanel {
	/**
	 * @param map
	 */
	public ButtonsPanel(ActionMap map) {
		super();
		setActionMap(map);
		initialize();
	}
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JPanel westPanel = null;
	private javax.swing.JPanel eastPanel = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JToggleButton jToggleButton = null;
	private javax.swing.JToggleButton jToggleButton1 = null;
	private javax.swing.JToggleButton jToggleButton2 = null;
	private javax.swing.JToggleButton jToggleButton3 = null;
	private javax.swing.JToggleButton jToggleButton4 = null;
	private javax.swing.JToggleButton jToggleButton5 = null;
	private javax.swing.JToggleButton jToggleButton6 = null;

	private void initialize() {
        this.setLayout(new java.awt.BorderLayout());
        this.add(getJPanel(), java.awt.BorderLayout.CENTER);
	}
	
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = MacLafFactory.createPanel();
			jPanel.setLayout(new java.awt.BorderLayout());
			jPanel.add(getWestPanel(), java.awt.BorderLayout.WEST);
			jPanel.add(getEastPanel(), java.awt.BorderLayout.EAST);
			jPanel.add(getJLabel(), java.awt.BorderLayout.CENTER);
		}
		return jPanel;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getWestPanel() {
		if(westPanel == null) {
			westPanel = MacLafFactory.createPanel();
			westPanel.add(getJToggleButton(), null);
			westPanel.add(getJToggleButton1(), null);
			westPanel.add(getJToggleButton2(), null);
			westPanel.add(getArtworkButton(), null);
		}
		return westPanel;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getEastPanel() {
		if(eastPanel == null) {
			eastPanel = MacLafFactory.createPanel();
			eastPanel.add(getJToggleButton4(), null);
			eastPanel.add(getJToggleButton5(), null);
			eastPanel.add(getJToggleButton6(), null);
		}
		return eastPanel;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("Status");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	
	/**
	 * This method initializes jToggleButton
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton() {
		if(jToggleButton == null) {
			jToggleButton = MacLafFactory.createImageToggleButton("add");
			controller.ActionFactory.setAction(jToggleButton,getActionMap(),controller.ActionFactory.NEW_LIST);
		}
		return jToggleButton;
	}
	/**
	 * This method initializes jToggleButton1
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton1() {
		if(jToggleButton1 == null) {
			jToggleButton1 = MacLafFactory.createImageToggleButton("suffle");
		}
		return jToggleButton1;
	}
	/**
	 * This method initializes jToggleButton2
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton2() {
		if(jToggleButton2 == null) {
			jToggleButton2 = MacLafFactory.createImageToggleButton("repeat");
		}
		return jToggleButton2;
	}
	/**
	 * This method initializes jToggleButton3
	 * 
	 * @return javax.swing.JToggleButton
	 */
	public javax.swing.JToggleButton getArtworkButton() {
		if(jToggleButton3 == null) {
			jToggleButton3 = MacLafFactory.createImageToggleButton("artwork");
			jToggleButton3.setSelected(true);
			controller.ActionFactory.setAction(jToggleButton3,getActionMap(),controller.ActionFactory.ARTWORK);
		}
		return jToggleButton3;
	}
	/**
	 * This method initializes jToggleButton4
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton4() {
		if(jToggleButton4 == null) {
			jToggleButton4 = MacLafFactory.createImageToggleButton("equalizer");
		}
		return jToggleButton4;
	}
	/**
	 * This method initializes jToggleButton5
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton5() {
		if(jToggleButton5 == null) {
			jToggleButton5 = MacLafFactory.createImageToggleButton("visualizer");
		}
		return jToggleButton5;
	}
	/**
	 * This method initializes jToggleButton6
	 * 
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButton6() {
		if(jToggleButton6 == null) {
			jToggleButton6 = MacLafFactory.createImageToggleButton("eject");
		}
		return jToggleButton6;
	}
	/* (non-Javadoc)
	 * @see java.awt.Component#setFont(java.awt.Font)
	 */
	public void setFont(Font font) {
		getJLabel().setFont(font);
		super.setFont(font);
	}

	/**
	 * 
	 */
	public void artworkOff() {
		getArtworkButton().setSelected(false);
		updateUI();
	}

	/**
	 * 
	 */
	public void artworkOn() {
		getArtworkButton().setSelected(true);
		updateUI();
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
