package gui;

import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.DefaultCellEditor;
import javax.swing.JOptionPane;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import laf.mac.MacLafFactory;
import model.api.Song;
import controller.ActionController;


/*
 * Created on 2004. 1. 14.
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ComponentComposor {
	private ActionController controller = null;
	private java.awt.Font biggerFont = new java.awt.Font("Lucida Bright", java.awt.Font.PLAIN, 12);
	private java.awt.Font smallerFont = new java.awt.Font("Lucida Bright", java.awt.Font.PLAIN, 11);

	private laf.mac.MacFrame macFrame = null;  //  @jve:visual-info  decl-index=0 visual-constraint="22,20"
	private javax.swing.JFrame jFrame = null;  //  @jve:visual-info  decl-index=0 visual-constraint="75,33"
	private javax.swing.JPanel jContentPane = null;

	private gui.PlayerPanel playerPanel = null;
	private gui.ButtonsPanel buttonsPanel = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JSplitPane jSplitPane = null;
	private gui.PlaylistTablePanel playlistTablePanel = null;
	private gui.SongTablePanel songTablePanel = null;
	private MenuComposor menuComposer = null;
	/**
	 * 
	 */
	public ComponentComposor(ActionController controller) {
		super();
		this.controller = controller;
		controller.setComponentComposor(this);
		initialize();
//		new java.awt.dnd.DropTarget(getJFrame(),java.awt.dnd.DnDConstants.ACTION_COPY,controller,true);
		getJFrame().pack();
		getJFrame().show();
	}
	/**
	 * 
	 */
	private void initialize() {		
		getJFrame();
		this.previosSong(false);
		this.nextSong(false);
	}

	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	private javax.swing.JFrame getJFrame() {
		if(jFrame == null) {
			jFrame = MacLafFactory.createFrame();	
			jFrame.setSize(500, 700);
			jFrame.setJMenuBar(getJMenuBar());
			jFrame.setFont(new java.awt.Font("Lucida Sans Unicode", java.awt.Font.PLAIN, 12));
			jFrame.setTitle("comsTunez");
			jFrame.setName("mainFrame");
			jFrame.setLocation(100, 100);
			jFrame.setResizable(true);
			jFrame.getContentPane().add(getJPanel(), java.awt.BorderLayout.CENTER);
		}
		return jFrame;
	}
	/**
	 * @return
	 */
	private javax.swing.JMenuBar getJMenuBar() {
		return getMenuComposer().getJMenuBar();
	}
	public MenuComposor getMenuComposer(){
		if (menuComposer == null) {
			menuComposer = new MenuComposor(biggerFont,smallerFont,controller.getActionMap());
		}
		return menuComposer;
	}
	/**
	 * This method initializes playerPanel
	 * 
	 * @return uiComponent.PlayerPanel
	 */
	private gui.PlayerPanel getPlayerPanel() {
		if(playerPanel == null) {
			playerPanel = new gui.PlayerPanel(controller.getActionMap());
			playerPanel.setFont(smallerFont);
			playerPanel.getControlPanel().getVolumeSlider().addChangeListener(new ChangeListener(){
				public void stateChanged(ChangeEvent e) {
					javax.swing.JSlider source = (javax.swing.JSlider)e.getSource();
					if(!source.getValueIsAdjusting()){
						controller.updateVolume(source); 
					}
				}});
			playerPanel.setPreferredSize(new Dimension(100,80));
		}
		return playerPanel;
	}
	/**
	 * This method initializes buttonsPanel
	 * 
	 * @return gui.ButtonsPanel
	 */
	private gui.ButtonsPanel getButtonsPanel() {
		if(buttonsPanel == null) {
			buttonsPanel = new gui.ButtonsPanel(controller.getActionMap());
			buttonsPanel.setPreferredSize(new Dimension(100,30));
			buttonsPanel.setFont(smallerFont);
		}
		return buttonsPanel;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(new java.awt.BorderLayout());
			jPanel.add(getButtonsPanel(), java.awt.BorderLayout.SOUTH);
			jPanel.add(getPlayerPanel(), java.awt.BorderLayout.NORTH);
			jPanel.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
			// TODO հ ũ   ʿϴ
//			jPanel.setPreferredSize(new java.awt.Dimension(390,590));
		}
		return jPanel;
	}
	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private javax.swing.JSplitPane getJSplitPane() {
		if(jSplitPane == null) {
			jSplitPane = MacLafFactory.createSplitPane();
			jSplitPane.setLeftComponent(getPlaylistTablePanel());
			jSplitPane.setRightComponent(getSongTablePanel());

			// TODO Ʈũ ũⰡ ڵ   ְ 
			jSplitPane.setDividerLocation(0.25);
		}
		return jSplitPane;
	}
	/**
	 * This method initializes libraryTreePanel
	 * 
	 * @return gui.LibraryTreePanel
	 */
	private gui.PlaylistTablePanel getPlaylistTablePanel() {
		if(playlistTablePanel == null) {
			playlistTablePanel = new gui.PlaylistTablePanel();
			playlistTablePanel.setFont(smallerFont);
			playlistTablePanel.getJTable().setModel(controller.getLibraryModel());
			playlistTablePanel.getJTable().getSelectionModel().addListSelectionListener(new javax.swing.event.ListSelectionListener(){
				public void valueChanged(javax.swing.event.ListSelectionEvent e) {
					if(!e.getValueIsAdjusting()){
						controller.changeSongTable(e);
					}
				}});
			playlistTablePanel.getJTable().getSelectionModel().addSelectionInterval(0,0);
			controller.changeSongTable(new javax.swing.event.ListSelectionEvent(playlistTablePanel.getJTable().getSelectionModel(),0,0,true));
			DefaultCellEditor tableCellEditor = new DefaultCellEditor(new javax.swing.JTextField());
			tableCellEditor.addCellEditorListener(new CellEditorListener(){
				public void editingCanceled(ChangeEvent e) {}
				public void editingStopped(ChangeEvent e) {	
					DefaultCellEditor editor = 	(DefaultCellEditor)e.getSource();					
						controller.setPlaylistName((String)editor.getCellEditorValue(),playlistTablePanel.getJTable().getSelectionModel().getAnchorSelectionIndex());
				}}); 
			playlistTablePanel.getJTable().setDefaultEditor(Object.class,tableCellEditor);
		}
		return playlistTablePanel;
	}
	/**
	 * This method initializes songTablePanel
	 * 
	 * @return gui.SongTablePanel
	 */
	private gui.SongTablePanel getSongTablePanel() {
		if(songTablePanel == null) {
			songTablePanel = new gui.SongTablePanel();
			songTablePanel.setFont(smallerFont);
			songTablePanel.getJTable().addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					if(e.getClickCount() == 2 && e.getButton() == MouseEvent.BUTTON1){
						controller.play(null);
					}
				}
			});			
		}
		return songTablePanel;
	}

	/**
	 * 
	 */
	public void browserOff() {
		this.getMenuComposer().browserOff();
		this.getSongTablePanel().browserOff();
	}

	/**
	 * 
	 */
	public void browserOn() {
		this.getMenuComposer().browserOn();
		this.getSongTablePanel().browserOn();
	}

	/**
	 * 
	 */
	public void artworkOff() {
		this.getMenuComposer().artworkOff();
		this.getButtonsPanel().artworkOff();
		this.getPlaylistTablePanel().artworkOff();		
	}

	/**
	 * @param object
	 */
	public void artworkOn(java.awt.Image image) {
		this.getMenuComposer().artworkOn();
		this.getButtonsPanel().artworkOn();
		this.getPlaylistTablePanel().artworkOn(image);
	}

	/**
	 * 
	 */
	public void readyStop() {
		this.getPlayerPanel().getControlPanel().readyStop();
		this.getMenuComposer().readyStop();
	}

	/**
	 * 
	 */
	public void readyPlay() {		
		this.getPlayerPanel().getControlPanel().readyPlay();
		this.getMenuComposer().readyPlay();
	}

	/**
	 * 
	 */
	public void readyPause() {
		this.getPlayerPanel().getControlPanel().readyPause();
		this.getMenuComposer().readyPause();
	}
	/**
	 * 
	 */
	public void cancelMute() {
		this.getMenuComposer().cancelMute();
	}

	/**
	 * 
	 */
	public javax.swing.JTable getPlaylistTable() {
		return this.getPlaylistTablePanel().getJTable();
	}

	/**
	 * 
	 */
	public javax.swing.JTable getSongTable() {
		return this.getSongTablePanel().getJTable();		
	}

	/**
	 * 
	 */
	public void previosSong(boolean b) {
		getMenuComposer().previosSongMenuitem(b);
		getPlayerPanel().getControlPanel().getPrevButton().setEnabled(b);
	}

	/**
	 * 
	 */
	public void nextSong(boolean b) {
		getMenuComposer().nextSongMenuitem(b);
		getPlayerPanel().getControlPanel().getNextButton().setEnabled(b);
	}

	/**
	 * 
	 */
	public javax.swing.JSlider getVolumeSlider() {
		return getPlayerPanel().getControlPanel().getVolumeSlider();
	}

	/**
	 * @param song
	 */
	public void setCurruntSong(Song song) {
		java.util.Vector vector = new java.util.Vector();
		if(song.getName() != null){
			vector.add(song.getName());			
		}
		if(song.getArtist() != null){
			vector.add(song.getArtist());			
		}
		if(song.getAlbum() != null){
			vector.add(song.getAlbum());			
		}		
		this.getPlayerPanel().getDisplayPanel().setTitles((String[]) vector.toArray(new String[]{}));
	}
	public void clearCurrentSong(){
		this.getPlayerPanel().getDisplayPanel().setTitles(null);
	}

	/**
	 * @param cursor
	 * @param total
	 */
	public void setTimeData(int cursor, int total) {
		getPlayerPanel().getDisplayPanel().setTimeDate(cursor, total);
	}
	/**
	 * 
	 */
	public void showAbout() {
		JOptionPane.showMessageDialog(getJFrame(),"All Copyrights reserved COM's");
	}
}
