package gui;
import gui.component.ControlPanel;
import gui.component.DisplayPanel;
import gui.component.FilterPanel;

import java.awt.BorderLayout;
import java.awt.Font;

import javax.swing.ActionMap;
import javax.swing.JPanel;

import laf.mac.MacLafFactory;

/*
 * Created on 2004. 1. 21.
 *
 */

/**
 * @author hyoki
 *
 */
public class PlayerPanel extends JPanel {

	private ControlPanel controlPanel = null;
	private DisplayPanel displayPanel = null;
	private FilterPanel filterPanel = null;
	private javax.swing.JPanel jPanel = null;
	/**
	 * This is the default constructor
	 */
	public PlayerPanel(ActionMap map) {
		super();
		setActionMap(map);
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		javax.swing.JPanel temp = new javax.swing.JPanel(new BorderLayout());
		temp.add(getDisplayPanel(), BorderLayout.CENTER);
		temp.add(MacLafFactory.createPanel(), BorderLayout.WEST);
		temp.add(MacLafFactory.createPanel(), BorderLayout.EAST); 
		this.add(temp, java.awt.BorderLayout.CENTER);
		this.add(getJPanel(), java.awt.BorderLayout.SOUTH);
		this.add(getFilterPanel(), java.awt.BorderLayout.EAST);
		this.add(getControlPanel(), java.awt.BorderLayout.WEST);
	}
	/**
	 * This method initializes controlPanel
	 * 
	 * @return ControlPanel
	 */
	public ControlPanel getControlPanel() {
		if(controlPanel == null) {
			controlPanel = new ControlPanel(getActionMap());
		}
		return controlPanel;
	}
	/**
	 * This method initializes displayPanel
	 * 
	 * @return DisplayPanel
	 */
	public DisplayPanel getDisplayPanel() {
		if(displayPanel == null) {
			displayPanel = new DisplayPanel(getActionMap());
		}
		return displayPanel;
	}
	/**
	 * This method initializes filterPanel
	 * 
	 * @return FilterPanel
	 */
	public FilterPanel getFilterPanel() {
		if(filterPanel == null) {
			filterPanel = new FilterPanel(getActionMap());
			filterPanel.setPreferredSize(new java.awt.Dimension(200,80));
		}
		return filterPanel;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = MacLafFactory.createPanel();
		}
		return jPanel;
	}
	/* (non-Javadoc)
	 * @see java.awt.Component#setFont(java.awt.Font)
	 */
	public void setFont(Font font) {
		getDisplayPanel().setFont(font);
		super.setFont(font);
	}

}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
