/*
 * Created on 2004. 1. 27.
 *
 */
package gui;

import java.awt.Font;
import java.awt.Image;

import javax.swing.JPanel;
import javax.swing.table.DefaultTableCellRenderer;

import laf.mac.MacLafFactory;

/**
 * @author hyoki
 *
 */
public class PlaylistTablePanel extends JPanel {
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JSplitPane jSplitPane = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JLabel jLabel1 = null;
	private gui.component.Artwork artwork = null;
	private javax.swing.JTable jTable = null;
	/**
	 * This is the default constructor
	 */
	public PlaylistTablePanel() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getJPanel(), java.awt.BorderLayout.CENTER);
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = MacLafFactory.createPanel();
			jPanel.setLayout(new java.awt.BorderLayout());
			jPanel.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		}
		return jPanel;
	}
	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private javax.swing.JSplitPane getJSplitPane() {
		if(jSplitPane == null) {
			jSplitPane = MacLafFactory.createSplitPane();
			jSplitPane.setTopComponent(getJPanel1());
			jSplitPane.setBottomComponent(getJPanel2());			
			jSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
			jSplitPane.setDividerLocation(0.30);					
		}
		return jSplitPane;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if(jPanel1 == null) {
			jPanel1 = MacLafFactory.createPanel();
			jPanel1.setLayout(new java.awt.BorderLayout());
			jPanel1.add(getJLabel(), java.awt.BorderLayout.NORTH);
			jPanel1.add(getJScrollPane(), java.awt.BorderLayout.CENTER);			
		}		
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if(jPanel2 == null) {
			jPanel2 = MacLafFactory.createPanel();
			jPanel2.setLayout(new java.awt.BorderLayout());
			jPanel2.add(getJLabel1(), java.awt.BorderLayout.NORTH);
			jPanel2.add(getArtwork(), java.awt.BorderLayout.CENTER);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = MacLafFactory.createLabel();
			jLabel.setText("Source");
		}
		return jLabel;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = MacLafFactory.createScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = MacLafFactory.createLabel();
			jLabel1.setText("Now Playing");			
		}
		return jLabel1;
	}
	/**
	 * This method initializes artwork
	 * 
	 * @return uiComponent.Artwork
	 */
	private gui.component.Artwork getArtwork() {
		if(artwork == null) {
			artwork = new gui.component.Artwork();
		}
		return artwork;
	}
	/* (non-Javadoc)
	 * @see java.awt.Component#setFont(java.awt.Font)
	 */
	public void setFont(Font font) {
		getJLabel().setFont(font);
		getJLabel1().setFont(font);
		getJTable().setFont(font);
		getArtwork().setFont(font);
		super.setFont(font);
	}
	/**
	 * 
	 */
	public void artworkOff() {
		getJPanel().remove(getJSplitPane());
		getJPanel().add(getJPanel1(),java.awt.BorderLayout.CENTER);
		updateUI();
	}

	/**
	 * @param image
	 */
	public void artworkOn(Image image) {
		getJPanel().remove(getJPanel1());
		getJPanel().add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		getJSplitPane().setTopComponent(getJPanel1());
		getJSplitPane().setBottomComponent(getJPanel2());
		updateUI();
	}

	/**
	 * This method initializes jList
	 * 
	 * @return javax.swing.JList
	 */
	public javax.swing.JTable getJTable() {
		if(jTable == null) {
			jTable = MacLafFactory.createTable();	
			jTable.getTableHeader().setDefaultRenderer(new DefaultTableCellRenderer());
			jTable.setDefaultRenderer(Object.class,new DefaultTableCellRenderer());
			jTable.setSelectionBackground(new java.awt.Color(57,130,222));
			jTable.setSelectionForeground(java.awt.Color.WHITE);
			jTable.setCellSelectionEnabled(true);
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
			jTable.getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
		}		
		return jTable;
	}
}
