/*
 * Created on 2004. 1. 27.
 *
 */
package gui;

import java.awt.Font;

import javax.swing.JPanel;

import laf.mac.MacLafFactory;

/**
 * @author hyoki
 *
 */
public class SongTablePanel extends JPanel {
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JSplitPane jSplitPane = null;
	private gui.BrowsePanel browsePanel = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JScrollPane jScrollPane = null;
	/**
	 * This is the default constructor
	 */
	public SongTablePanel() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getJPanel(), java.awt.BorderLayout.CENTER);
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = MacLafFactory.createPanel();
			jPanel.setLayout(new java.awt.BorderLayout());
			jPanel.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		}
		return jPanel;
	}
	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private javax.swing.JSplitPane getJSplitPane() {
		if(jSplitPane == null) {
			jSplitPane = MacLafFactory.createSplitPane();
			jSplitPane.setTopComponent(getBrowsePanel());
			jSplitPane.setBottomComponent(getJScrollPane());
			jSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
		}
		return jSplitPane;
	}
	/**
	 * This method initializes browsePanel
	 * 
	 * @return gui.BrowsePanel
	 */
	private gui.BrowsePanel getBrowsePanel() {
		if(browsePanel == null) {
			browsePanel = new gui.BrowsePanel();
		}
		return browsePanel;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	public javax.swing.JTable getJTable() {
		if(jTable == null) {
			jTable = MacLafFactory.createTable();
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = MacLafFactory.createScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}
	/* (non-Javadoc)
	 * @see java.awt.Component#setFont(java.awt.Font)
	 */
	public void setFont(Font font) {
		getBrowsePanel().setFont(font);
		getJTable().setFont(font);
		super.setFont(font);
	}
	/**
	 * 
	 */
	public void browserOff() {
		getJPanel().remove(jSplitPane);
		getJPanel().add(getJScrollPane(),java.awt.BorderLayout.CENTER);
		updateUI();
	}
	/**
	 * 
	 */
	public void browserOn() {
		getJPanel().remove(getJScrollPane());
		getJPanel().add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		getJSplitPane().setBottomComponent(getJScrollPane());
		updateUI();
	}
}
