package gui.component;

import java.awt.Dimension;
import java.util.Observable;
import java.util.Observer;

import laf.mac.MacLafFactory;
import controller.ActionFactory;

/*
 * Created on 2004. 1. 21.
 *
 */

/**
 * @author hyoki
 *
 */
public class ControlPanel extends javax.swing.JPanel implements Observer {

	private javax.swing.JPanel controlPanel = null;
	private javax.swing.JPanel paddingPanel = null;
	private javax.swing.JButton playButton = null;
	private javax.swing.JButton stopButton = null;
	private javax.swing.JButton pauseButton = null;
	private javax.swing.JButton previousButton = null;
	private javax.swing.JButton nextButton = null;
	private javax.swing.JSlider volumeSlider = null;
	private javax.swing.JPanel volumePanel = null;
	private javax.swing.JLabel volumeDownLabel = null;
	private javax.swing.JLabel volumeUpLabel = null;
	
	private javax.swing.JButton statusButton = null;
	private javax.swing.JPanel jPanel = null;
	/**
	 * This is the default constructor
	 */
	public ControlPanel(javax.swing.ActionMap map) {
		super();
		setActionMap(map);
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getControlPanel(), java.awt.BorderLayout.CENTER);
		this.add(getPaddingPanel(), java.awt.BorderLayout.EAST);
		this.add(getJPanel(), java.awt.BorderLayout.WEST);
		getPaddingPanel().setPreferredSize(getControlPanel().getPreferredSize());
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getControlPanel() {
		if(controlPanel == null) {
			controlPanel = MacLafFactory.createPanel();
			controlPanel.setLayout(new java.awt.BorderLayout());
			getControlPanel().add(getPlayButton(), java.awt.BorderLayout.CENTER,0);
			controlPanel.add(getPrevButton(), java.awt.BorderLayout.WEST);
			controlPanel.add(getNextButton(), java.awt.BorderLayout.EAST);
			controlPanel.add(getVolumePanel(), java.awt.BorderLayout.SOUTH);
			int width = getPrevButton().getIcon().getIconWidth() + getPlayButton().getIcon().getIconWidth() + getNextButton().getIcon().getIconWidth()+ 10;
			int height = getPlayButton().getIcon().getIconHeight() +  getVolumeUpLabel().getIcon().getIconHeight()+ 20;
			controlPanel.setPreferredSize(new Dimension(width, height));
		}
		return controlPanel;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPaddingPanel() {
		if(paddingPanel == null) {
			paddingPanel = MacLafFactory.createPanel();
		}
		return paddingPanel;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	public javax.swing.JButton getPlayButton() {
		if(playButton == null) {
			playButton = MacLafFactory.createImageButton("play");
			ActionFactory.setAction(playButton,getActionMap(),ActionFactory.PLAY);
			int width = playButton.getIcon().getIconWidth();
			int height = playButton.getIcon().getIconHeight();
			playButton.setPreferredSize(new Dimension(width, height));	
		}
		return playButton;
	}
	public javax.swing.JButton getStopButton() {
		if (stopButton == null) {
			stopButton = MacLafFactory.createImageButton("stop");
			ActionFactory.setAction(stopButton,getActionMap(),ActionFactory.STOP);			
			int width = stopButton.getIcon().getIconWidth();
			int height = stopButton.getIcon().getIconHeight();
			stopButton.setPreferredSize(new Dimension(width, height));	
		}
		return stopButton;
	}
	public javax.swing.JButton getPauseButton() {
		if (pauseButton == null) {
			pauseButton = MacLafFactory.createImageButton("pause");
			ActionFactory.setAction(pauseButton,getActionMap(),ActionFactory.PAUSE);			
			int width = pauseButton.getIcon().getIconWidth();
			int height = pauseButton.getIcon().getIconHeight();
			pauseButton.setPreferredSize(new Dimension(width, height));	
		}
		return pauseButton;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	public javax.swing.JButton getPrevButton() {
		if(previousButton == null) {
			previousButton = MacLafFactory.createImageButton("previous");
			ActionFactory.setAction(previousButton,getActionMap(),ActionFactory.PREVIOS_SONG);
		}
		return previousButton;
	}
	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	public javax.swing.JButton getNextButton() {
		if(nextButton == null) {
			nextButton = MacLafFactory.createImageButton("next");
			ActionFactory.setAction(nextButton,getActionMap(),ActionFactory.NEXT_SONG);
		}
		return nextButton;
	}
	/**
	 * This method initializes jSlider
	 * 
	 * @return javax.swing.JSlider
	 */
	public javax.swing.JSlider getVolumeSlider() {
		if(volumeSlider == null) {
			volumeSlider = MacLafFactory.createSlider();
			volumeSlider.setPaintTicks(false);
			volumeSlider.setValueIsAdjusting(true);
			volumeSlider.setOpaque(false);
			volumeSlider.setMinimum(0);
			volumeSlider.setMaximum(100);
		}
		return volumeSlider;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getVolumePanel() {
		if(volumePanel == null) {
			volumePanel = MacLafFactory.createPanel();
			volumePanel.setLayout(new java.awt.BorderLayout());
			volumePanel.add(getVolumeSlider(), java.awt.BorderLayout.CENTER);
			volumePanel.add(getVolumeDownLabel(), java.awt.BorderLayout.EAST);
			volumePanel.add(getVolumeUpLabel(), java.awt.BorderLayout.WEST);
			int width = (getVolumeDownLabel().getIcon().getIconWidth() + getVolumeUpLabel().getIcon().getIconWidth()) * 5;
			int height = getVolumeUpLabel().getIcon().getIconHeight() + 10;
			volumePanel.setMinimumSize(new Dimension(width,height));
		}
		return volumePanel;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getVolumeDownLabel() {
		if(volumeDownLabel == null) {
			volumeDownLabel = MacLafFactory.createImageLabel("volumeUp");
		}
		return volumeDownLabel;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getVolumeUpLabel() {
		if(volumeUpLabel == null) {
			volumeUpLabel = MacLafFactory.createImageLabel("volumeDown");
		}
		return volumeUpLabel;
	}
	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable o, Object arg) {
		// TODO Observable     ʿϴ.
		int status = 0;
		if(status == 0 ){
			statusButton  = getPlayButton();
		}else if( status == 1){
			statusButton = getStopButton();
		}else if(status == 2){
			statusButton = getPauseButton();
		}
		updateUI();
	}
	public int getValue(){
		return getVolumeSlider().getValue();
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = MacLafFactory.createPanel();
		}
		return jPanel;
	}
	public void readyPlay(){
		getControlPanel().remove(0);
		getControlPanel().add(getPlayButton(), java.awt.BorderLayout.CENTER,0);
		updateUI();
	}
	public void readyStop(){
		getControlPanel().remove(0);
		getControlPanel().add(getStopButton(), java.awt.BorderLayout.CENTER,0);
		updateUI();
	}
	public void readyPause(){
		getControlPanel().remove(0);
		getControlPanel().add(getPauseButton(), java.awt.BorderLayout.CENTER,0);
		updateUI();
	}
}
