package gui.component;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import laf.mac.MacLafFactory;

/*
 * Created on 2004. 1. 21.
 *
 */

/**
 * @author hyoki
 *
 */
public class DisplayPanel extends JPanel {

	private String[] titles;
	private javax.swing.JButton imformationButton = null;
	private javax.swing.JButton noticeDeleteButton = null;
	private javax.swing.JPanel displayPanel = null;
	private javax.swing.JLabel timeLabel = null;
	private javax.swing.JProgressBar songProgressBar = null;
	private javax.swing.JPanel contentPanel = null;
	private javax.swing.JLabel titleLabel = null;
	/**
	 * This is the default constructor
	 */
	public DisplayPanel(javax.swing.ActionMap map) {
		super();
		setActionMap(map);
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getContentPanel(), java.awt.BorderLayout.CENTER);
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getImformationButton() {
		if(imformationButton == null) {
			imformationButton = MacLafFactory.createImageButton("select");
		}
		return imformationButton;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getNoticeDeleteButton() {
		if(noticeDeleteButton == null) {
			noticeDeleteButton = MacLafFactory.createImageButton("delete");
			noticeDeleteButton.setEnabled(false);
		}
		return noticeDeleteButton;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getDisplayPanel() {
		if(displayPanel == null) {		
			displayPanel = MacLafFactory.createDisplayPanel();			
			displayPanel.setLayout(new java.awt.BorderLayout());
			displayPanel.add(getTimeLabel(), java.awt.BorderLayout.CENTER);
			displayPanel.add(getSongProgressBar(), java.awt.BorderLayout.SOUTH);
			displayPanel.add(getTitleLabel(), java.awt.BorderLayout.NORTH);
		}
		return displayPanel;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	public javax.swing.JLabel getTimeLabel() {
		if(timeLabel == null) {
			timeLabel = new javax.swing.JLabel();
			timeLabel.setText(" ");
			timeLabel.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					changeTimeMode();
				}
			});
		}
		return timeLabel;
	}
	private int currentMode = 0;
	/**
	 * 
	 */
	protected void changeTimeMode() {
		if(currentMode < 2){
			currentMode++;
		}else{
			currentMode = 0;
		}
	}
	private int titleIndex = 0;
	/**
	 * @return
	 */
	protected String getNextTitle() {
		if(this.titles == null){
			titleIndex = 0;
			return " ";
		}
		if(titleIndex >= titles.length){
			titleIndex = 0;
		}
		return titles[titleIndex++];		
	}
	/**
	 * This method initializes jProgressBar
	 * 
	 * @return javax.swing.JProgressBar
	 */
	private javax.swing.JProgressBar getSongProgressBar() {
		if(songProgressBar == null) {
			songProgressBar = MacLafFactory.createProgressBar();
		}
		return songProgressBar;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getContentPanel() {
		if(contentPanel == null) {
			contentPanel = MacLafFactory.createPanel();
			contentPanel.setLayout(new GridBagLayout());
			contentPanel.add(getImformationButton(), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 4));
			JPanel temp = new JPanel(new BorderLayout());
			temp.add(getDisplayPanel(),BorderLayout.CENTER);
			contentPanel.add(temp, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
			contentPanel.add(getNoticeDeleteButton(), new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 4));
			contentPanel.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));			
		}
		return contentPanel;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	public javax.swing.JLabel getTitleLabel() {
		if(titleLabel == null) {
			titleLabel = new javax.swing.JLabel();
			titleLabel.setText(" ");
			titleLabel.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				getTitleLabel().setText(getNextTitle());
			}});
		}
		return titleLabel;
	}
	/**
	 * @param iterator
	 */
	public void setTitles(String[] strings) {
		titleIndex = 0;
		titles = strings;
		getTitleLabel().setText(getNextTitle());
	}
	/**
	 * @param cursor
	 * @param total
	 */
	public void setTimeDate(int cursor, int total) {
		String displayString = null;
		int displayTime = 0;
		switch (currentMode) {
			case 0 :
				displayString = "Total Time";
				displayTime = total;
				break;
			case 1 :
				displayString = "Elapsed Time";
				displayTime = cursor;
				break;
			case 2 :
				displayString = "Remaining Time";
				displayTime = total-cursor;
				break;
			default :
				break;
		}
		showTime(displayString,displayTime);
		getSongProgressBar().setMaximum(total);
		getSongProgressBar().setValue(cursor);
	}
	/**
	 * @param displayString
	 * @param displayTime
	 */
	private void showTime(String displayString, int displayTime) {
		String result = displayString + ": "+ displayTime/60+":"+(displayTime%60<10?"0":"")+displayTime%60 ;
		this.getTimeLabel().setText(result);
	}
}
