package gui.component;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JPanel;

import laf.mac.MacLafFactory;

/*
 * Created on 2004. 1. 21.
 *
 */

/**
 * @author hyoki
 *
 */
public class SearchPanel extends JPanel {

	private javax.swing.JTextField searchTextField = null;
	private javax.swing.JButton searchButton = null;
	private javax.swing.JButton deleteFieldButton = null;
	/**
	 * This is the default constructor
	 */
	public SearchPanel() {
		super();		
		initialize();		
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.GridBagLayout());
		this.add(getSearchButton(), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		this.add(getSearchTextField(),  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 4));
		this.add(getDeleteFieldButton(), new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		getSearchTextField().addKeyListener(new KeyAdapter(){/* (non-Javadoc)
			 * @see java.awt.event.KeyAdapter#keyTyped(java.awt.event.KeyEvent)
			 */
			public void keyTyped(KeyEvent e) {
				getDeleteFieldButton().setEnabled(true);
			}});
		getDeleteFieldButton().addActionListener(new ActionListener(){/* (non-Javadoc)
			 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
			 */
			public void actionPerformed(ActionEvent e) {
				getSearchTextField().setText(null);
				getDeleteFieldButton().setEnabled(false);
			}});		
	}
	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getSearchTextField() {
		if(searchTextField == null) {
			searchTextField = MacLafFactory.createTextField();
		}
		return searchTextField;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getSearchButton() {
		if(searchButton == null) {
			searchButton = MacLafFactory.createImageButton("search");
		}
		return searchButton;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getDeleteFieldButton() {
		if(deleteFieldButton == null) {
			deleteFieldButton = MacLafFactory.createImageButton("deleteField");
			deleteFieldButton.setEnabled(false);
		}
		return deleteFieldButton;
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="46,16"
