/*
 * Created on 2004. 1. 17.
 *
 */
package laf.mac;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JSlider;
import javax.swing.SwingConstants;

import laf.mac.renderedUI.ComponentRenderer;

/**
 * @author hyoki
 *
 */
public class AquaRenderer implements ComponentRenderer{
	protected static String fileLocation = "/icons/aquaRender";
	protected static String controlButtonLocation = fileLocation+"/buttons";
	
	protected static ImageIcon close = loadIcon(getFileLocation()+"/red.gif");
	protected static ImageIcon closeOver = loadIcon(getFileLocation()+"/red_over.gif"); 
	protected static ImageIcon closePress = loadIcon(getFileLocation()+"/red_pressed.gif");

	protected static ImageIcon resize = loadIcon(getFileLocation()+"/green.gif");
	protected static ImageIcon resizeOver = loadIcon(getFileLocation()+"/green_over.gif");
	protected static ImageIcon resizePress = loadIcon(getFileLocation()+"/green_pressed.gif");
	
	protected static ImageIcon iconize = loadIcon(getFileLocation()+"/orange.gif");
	protected static ImageIcon iconizeOver = loadIcon(getFileLocation()+"/orange_over.gif");
	protected static ImageIcon iconizePress = loadIcon(getFileLocation()+"/orange_pressed.gif");
	
	protected static ImageIcon tableHeaderBackground = loadIcon(getFileLocation()+"/tableheader_background.gif");
	protected static ImageIcon tableHeaderSelected = loadIcon(getFileLocation() +"/tableheader_selected.gif");
	
	protected static ImageIcon scrollHorizontalDecrease = loadIcon(getFileLocation()+"/scroll_left.gif");
	protected static ImageIcon scrollHorizontalIncrease = loadIcon(getFileLocation()+"/scroll_right.gif");
	protected static ImageIcon scrollHorizontalBar = loadIcon(getFileLocation()+"/scroll_horizen.gif");
	protected static ImageIcon scrollHorizontalBackground = loadIcon(getFileLocation()+"/scroll_horizen_bg.gif");
	
	protected static ImageIcon scrollVerticalDecrease = loadIcon(getFileLocation()+"/scroll_top.gif");
	protected static ImageIcon scrollVerticalIncrease = loadIcon(getFileLocation()+"/scroll_Bottom.gif");
	protected static ImageIcon scrollVerticalBar = loadIcon(getFileLocation()+"/scroll_vertical.gif");
	protected static ImageIcon scrollVerticalBackground = loadIcon(getFileLocation()+"/scroll_vertical_bg.gif");
	
	protected static ImageIcon scrollButtonBottom = loadIcon(getFileLocation()+"/button_bottom.gif");
	protected static ImageIcon scrollButtonLeft = loadIcon(getFileLocation()+"/button_left.gif");
	protected static ImageIcon scrollButtonRight = loadIcon(getFileLocation()+"/button_right.gif");	
	protected static ImageIcon scrollButtonTop = loadIcon(getFileLocation()+"/button_top.gif");
	protected static ImageIcon scrollButtonBottomPress = loadIcon(getFileLocation()+"/button_bottom_press.gif");
	protected static ImageIcon scrollButtonLeftPress = loadIcon(getFileLocation()+"/button_left_press.gif");
	protected static ImageIcon scrollButtonRightPress = loadIcon(getFileLocation()+"/button_right_press.gif");
	protected static ImageIcon scrollButtonTopPress = loadIcon(getFileLocation()+"/button_top_press.gif");
	
	protected static ImageIcon search = loadIcon(getFileLocation()+"/search_text.gif");
	protected static ImageIcon searchButton = loadIcon(getFileLocation()+"/search_Button.gif");
	protected static ImageIcon deleteFieldButton = loadIcon(getFileLocation()+"/search_Delete.gif");
	protected static ImageIcon deleteFieldButtonDisable = loadIcon(getFileLocation()+"/search_Delete_disable.gif");
	
	protected static ImageIcon playButton = loadIcon(controlButtonLocation+"/play.gif");
	protected static ImageIcon pauseButton = loadIcon(controlButtonLocation+"/pause.gif");
	protected static ImageIcon stopButton = loadIcon(controlButtonLocation +"/stop.gif");
	protected static ImageIcon previousButton = loadIcon(controlButtonLocation+"/prev.gif");
	protected static ImageIcon nextButton = loadIcon(controlButtonLocation+"/next.gif");	
	protected static ImageIcon playButtonPress = loadIcon(controlButtonLocation+"/play_press.gif");
	protected static ImageIcon pauseButtonPress = loadIcon(controlButtonLocation+"/pause_press.gif");
	protected static ImageIcon stopButtonPress = loadIcon(controlButtonLocation +"/stop_press.gif");
	protected static ImageIcon previousButtonPress = loadIcon(controlButtonLocation+"/prev_press.gif");
	protected static ImageIcon nextButtonPress = loadIcon(controlButtonLocation+"/next_press.gif");
	protected static ImageIcon playButtonDisable = loadIcon(controlButtonLocation+"/play_disable.gif");
	protected static ImageIcon pauseButtonDisable = loadIcon(controlButtonLocation+"/pause_disable.gif");
	protected static ImageIcon stopButtonDisable = loadIcon(controlButtonLocation +"/stop_disable.gif");
	protected static ImageIcon previousButtonDisable = loadIcon(controlButtonLocation+"/prev_disable.gif");
	protected static ImageIcon nextButtonDisable = loadIcon(controlButtonLocation+"/next_disable.gif");	
	protected static ImageIcon browseButton = loadIcon(controlButtonLocation+"/browse.gif");
	protected static ImageIcon browseButtonPress = loadIcon(controlButtonLocation+"/browse_over.gif");
	protected static ImageIcon browseButtonDisable = loadIcon(controlButtonLocation+"/browse_disable.gif");

	protected static ImageIcon volumeTrack = loadIcon(controlButtonLocation+"/volume_track.gif");
	protected static ImageIcon volumeThumb = loadIcon(controlButtonLocation+"/volume_thumb.gif");
	protected static ImageIcon volumeDown = loadIcon(controlButtonLocation+"/volume_down.gif");
	protected static ImageIcon volumeUp = loadIcon(controlButtonLocation+"/volume_up.gif");
	
	protected static ImageIcon display = loadIcon(controlButtonLocation+"/display_body.gif");
	protected static ImageIcon selectButton = loadIcon(controlButtonLocation+"/display_select.gif");
	protected static ImageIcon selectButtonPress = loadIcon(controlButtonLocation+"/display_select_press.gif");
	protected static ImageIcon deleteButton = loadIcon(controlButtonLocation+"/display_delete.gif");
	protected static ImageIcon deleteButtonDisable = loadIcon(controlButtonLocation+"/display_delete_disable.gif");
	
	private static Hashtable labelTable = new Hashtable();
	private static Hashtable scrollTable = new Hashtable();	
	private static Hashtable buttonTable = new Hashtable();
	private static Hashtable colorTable = new Hashtable();
	
	static{
		labelTable.put("volumeUp", volumeUp);
		labelTable.put("volumeDown",volumeDown);
		
		scrollTable.put("scrollButtonBottom",scrollButtonBottom);
		scrollTable.put("pressedScrollButtonBottom",scrollButtonBottomPress);
		scrollTable.put("scrollButtonLeft",scrollButtonLeft);
		scrollTable.put("pressedScrollButtonLeft",scrollButtonLeftPress);
		scrollTable.put("scrollButtonRight",scrollButtonRight);
		scrollTable.put("pressedScrollButtonRight",scrollButtonRightPress);
		scrollTable.put("scrollButtonTop",scrollButtonTop);
		scrollTable.put("pressedScrollButtonTop",scrollButtonTopPress);
		
		buttonTable.put("playButton",playButton);
		buttonTable.put("pauseButton",pauseButton);
		buttonTable.put("stopButton",stopButton);
		buttonTable.put("previousButton",previousButton);
		buttonTable.put("nextButton",nextButton);
		buttonTable.put("playButtonPress",playButtonPress);
		buttonTable.put("pauseButtonPress",pauseButtonPress);
		buttonTable.put("stopButtonPress",stopButtonPress);
		buttonTable.put("previousButtonPress",previousButtonPress);
		buttonTable.put("nextButtonPress",nextButtonPress);
		buttonTable.put("playButtonDisable",playButtonDisable);
		buttonTable.put("stopButtonDisable",stopButtonDisable);
		buttonTable.put("previousButtonDisable",previousButtonDisable);
		buttonTable.put("nextButtonDisable",nextButtonDisable);		
		buttonTable.put("browseButton",browseButton);
		buttonTable.put("browseButtonPress",browseButtonPress);
		buttonTable.put("browseButtonDisable",browseButtonDisable);
		
		buttonTable.put("searchButton",searchButton);
		buttonTable.put("deleteFieldButton",deleteFieldButton);
		buttonTable.put("deleteFieldButtonDisable",deleteFieldButtonDisable);
		
		buttonTable.put("selectButton",selectButton);
		buttonTable.put("selectButtonPress",selectButtonPress);
		buttonTable.put("deleteButton",deleteButton);
		buttonTable.put("deleteButtonDisable",deleteButtonDisable);
		
		colorTable.put("evenBackground",Color.WHITE);
		colorTable.put("oddBackground",new Color(239,243,255));
		colorTable.put("selection",new Color(57,130,222));
		colorTable.put("forground",Color.BLACK);
		colorTable.put("selectionForground",Color.WHITE);		
	}
	
	private static ImageIcon loadIcon(String iconName) {
		return new ImageIcon(AquaRenderer.class.getResource(iconName));		
//		return new ImageIcon(iconName);
	}

	/**
	 * @return
	 */
	public static String getFileLocation() {		
		return fileLocation;
	}

	/**
	 * @param string
	 */
	public static void setFileLocation(String string) {
		fileLocation = string;
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#createScrollButton(int, int)
	 */
	public JButton createScrollButton(int ori) {
		JButton button = new JButton();
		button.setBorder(BorderFactory.createEmptyBorder());
		button.setMargin(new java.awt.Insets(0,0,0,0));
		button.setIcon((Icon)scrollTable.get("scrollButton"+getOrientationType(ori)));
		button.setPressedIcon((Icon)scrollTable.get("scrollButton"+getOrientationType(ori)+"Press"));
		return button;
	}

	/**
	 * @param ori
	 * @return
	 */
	private static String getOrientationType(int ori) {
		switch (ori) {
			case SwingConstants.EAST :
				return "Right";
			case SwingConstants.WEST :
				return "Left";
			case SwingConstants.NORTH :
				return "Top";
			case SwingConstants.SOUTH :
				return "Bottom";
			default :
				throw new UnsupportedOperationException();
		}
	}
	
	public void paintTableHeaderBG(Graphics g, JComponent columnHeader) {
		g.drawImage(tableHeaderBackground.getImage(),0,0,columnHeader.getWidth()+2,columnHeader.getHeight(),columnHeader);
	}
	public void paintTableHeaderSelected(Graphics g, JComponent columnHeader) {
		g.drawImage(tableHeaderSelected.getImage(),0,0,columnHeader.getWidth()+2,columnHeader.getHeight(),columnHeader);		
	}
	public void paintVerticalThumb(Graphics g, JComponent c, Rectangle bounds) {		
		int height = Math.min(bounds.height/2, scrollVerticalDecrease.getImage().getHeight(c));
		int width = scrollVerticalDecrease.getImage().getWidth(c);		
		g.drawImage(scrollVerticalBackground.getImage(), bounds.x+1, bounds.y, bounds.width-1, bounds.height,c);
		g.drawImage(scrollVerticalDecrease.getImage(), bounds.x+1, bounds.y,width,height,c);
		g.drawImage(scrollVerticalIncrease.getImage(), bounds.x+1, bounds.y+bounds.height-height, width, height, c);
		g.drawImage(scrollVerticalBar.getImage(), bounds.x+1, bounds.y+height, width, bounds.height-height-height, c);
	}
	public void paintHorizontalThumb(Graphics g, JComponent c, Rectangle bounds) {
		int height = scrollHorizontalDecrease.getImage().getHeight(c);
		int width = Math.min(bounds.width/2,scrollHorizontalDecrease.getImage().getWidth(c));
		g.drawImage(scrollHorizontalBackground.getImage(), bounds.x, bounds.y+1, bounds.width, bounds.height-1,c);
		g.drawImage(scrollHorizontalDecrease.getImage(), bounds.x, bounds.y+1,width, height, c);
		g.drawImage(scrollHorizontalIncrease.getImage(), bounds.x+bounds.width-width, bounds.y+1, width, height, c);
		g.drawImage(scrollHorizontalBar.getImage(), bounds.x+width, bounds.y+1, bounds.width-width-width, height, c);
	}
	public void paintVerticalTrack(Graphics g, JComponent c, Rectangle trackBounds) {
		this.paintTrack(g,c,trackBounds,scrollVerticalBackground.getImage());
	}
	private void paintTrack(Graphics g, JComponent c, Rectangle bounds, Image image) {
		g.drawImage(image, bounds.x, bounds.y+1, bounds.width, bounds.height-1,c);
	}
	public void paintHorizontalTrack(Graphics g, JComponent c, Rectangle trackBounds) {
		this.paintTrack(g,c,trackBounds,scrollHorizontalBackground.getImage());
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#getTableHeaderSize()
	 */
	public int getTableHeaderSize() {		
		return tableHeaderBackground.getIconHeight();
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#getColor(java.lang.String)
	 */
	public Color getColor(String string) {
		try {
			return (Color) colorTable.get(string);
		} catch (NullPointerException e) {
			throw new UnsupportedOperationException();
		}
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#paintSliderTrack(java.awt.Graphics, java.awt.Rectangle)
	 */
	public void paintSliderTrack(Graphics g, JSlider slider, Rectangle rectangle) {
		if(slider.getOrientation() == SwingConstants.HORIZONTAL){
			g.drawImage(volumeTrack.getImage(),rectangle.x,rectangle.y,rectangle.width,rectangle.height,slider);
		}
		// TODO orientation Vertical    Ѵ.
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#paintSliderThumb(java.awt.Graphics, javax.swing.JSlider, java.awt.Rectangle)
	 */
	public void paintSliderThumb(Graphics g, JSlider slider, Rectangle thumbRect) {
		if(slider.getOrientation() == SwingConstants.HORIZONTAL){
			thumbRect.setSize(volumeThumb.getIconWidth(), volumeThumb.getIconHeight());				
			g.drawImage(volumeThumb.getImage(),thumbRect.x, thumbRect.y ,thumbRect.width, thumbRect.height,slider);
		}
//		TODO orientation Vertical    Ѵ.
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#getLabelTable()
	 */
	public Hashtable getLabelTable() {
		return labelTable;
	}
	/**
	 * @return
	 */
	public Hashtable getButtonTable() {
		return buttonTable;
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#paintTextFieldBackground(java.awt.Graphics)
	 */
	public void paintTextFieldBackground(Graphics g, JComponent c) {
		g.drawImage(search.getImage(),0,0,c.getWidth(),c.getHeight(),c);
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#paint(java.awt.Graphics, javax.swing.JComponent)
	 */
	public void paint(Graphics g, JComponent c) {
		g.drawImage(display.getImage(),0,0,c.getWidth(),c.getHeight(),c);
	}
}
