package laf.mac;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import javax.swing.plaf.PanelUI;


/*
 * Created on 2004. 1. 14.
 */

/**
 * @author hyoki
 */
public class MacFrame extends JFrame {
	private ImageIcon getClose() {return AquaRenderer.close;}
	private ImageIcon getClose_Over() {return AquaRenderer.closeOver;}
	private ImageIcon getClose_Press() {return AquaRenderer.closePress;}
	private ImageIcon getIconize() {return AquaRenderer.iconize;}
	private ImageIcon getIconize_Over() {return AquaRenderer.iconizeOver;}
	private ImageIcon getIconize_Press() {return AquaRenderer.iconizePress;}
	private ImageIcon getResize() {return AquaRenderer.resize;}
	private ImageIcon getResize_Over() {return AquaRenderer.resizeOver;}
	private ImageIcon getResize_Press() {return AquaRenderer.resizePress;}	
	private ImageIcon getCornerIcon(){return MetalTexturer.corner;}
	
		
	public MacFrame() {
		super();
		initialize();		
	}
	private PanelUI panelUI = null;
	private JPanel buttonsPanel = null;
	private JLabel titleLabel = null;
	private JPanel contentPanel = new JPanel(){
		protected void addImpl(Component comp, Object constraints, int index) {
			if (comp instanceof javax.swing.JPanel){
				((javax.swing.JPanel)comp).setUI(panelUI);
				((javax.swing.JPanel)comp).setOpaque(false);
			}
			super.addImpl(comp, constraints, index);
		}
	};
	private JPanel titlebarPanel = null;
	private	Point pressPoint = null;
	private boolean resizing = false;
	private JMenuBar menuBar = null;
	
	private MouseListener resizingMouseListener = new MouseAdapter(){
		public void mousePressed(MouseEvent e) {
			Point point = new Point(e.getX(), e.getY());
			Component c =  e.getComponent();
			// TOTHINK  Ȯ ﰢ   ֵ ؾѴ.
//			if(((c.getWidth()-(point.x))*(c.getHeight()-point.y)) < MacFrame.corner.getIconWidth()* MacFrame.corner.getIconHeight()){			
			if(c.getWidth()-(point.x) + c.getHeight() - (point.y) < getCornerIcon().getIconHeight()){
				resizing=true;
			}
		}
		public void mouseReleased(MouseEvent e){
			if(resizing){
				validate();
			}
			resizing=false;
		}};
	private MouseMotionListener resizingMouseMotionListener = new MouseMotionAdapter(){
		public void mouseDragged(MouseEvent e) {
			if(resizing){
				Point point = e.getPoint();
				SwingUtilities.convertPointToScreen(point,e.getComponent());
				Dimension dim = new Dimension((point.x)-getLocation().x, (point.y) - getLocation().y);
				setSize(dim);
				fireResizeComponent();
			}
		}
		public void mouseMoved(MouseEvent e) {
			Point point = e.getPoint();
			Component c = e.getComponent();
			if(c.getWidth() - (point.x) + c.getHeight() - (point.y)<getCornerIcon().getIconHeight()){
				c.setCursor(Cursor.getPredefinedCursor(Cursor.SE_RESIZE_CURSOR));
			}else{
				c.setCursor(Cursor.getDefaultCursor());
			}
		}};
	private MouseListener dragMouseListener = new MouseAdapter(){
		public void mousePressed(MouseEvent e) {
			if(!isResizedTime(e)){
			Point point = new Point(e.getX(), e.getY());
			SwingUtilities.convertPointToScreen(point,e.getComponent());
			pressPoint = new Point((point.x)-getLocation().x, (point.y)-getLocation().y);
			}}
		};
	private MouseMotionListener dragMouseMotionListener = new MouseMotionAdapter(){
		public void mouseDragged(MouseEvent e) {
			if(!isResizedTime(e)){				
				Point point = e.getPoint();				
				SwingUtilities.convertPointToScreen(point,e.getComponent());
				setLocation(point.x-(pressPoint.x), point.y-(pressPoint.y));
			}}
		};	
	private boolean isFirstButton(MouseEvent e){
		return (e.getButton()==MouseEvent.BUTTON1);
	}
	/**
	 * 
	 */
	protected void fireResizeComponent() {
		ComponentEvent resize = new ComponentEvent(this, ComponentEvent.COMPONENT_RESIZED);
		// TODO  ȵȴ ~!!!
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {		
		super.setUndecorated(true);
		initializeSuper();
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);		
	}
	private void initializeSuper() {
		Container superPane = super.getContentPane();		
		superPane.setLayout(new BorderLayout());
		superPane.add(getTitlebarPanel(), BorderLayout.NORTH);
		superPane.add(contentPanel, BorderLayout.CENTER);
		addMouseActionListener(superPane);
	}
	private void addMouseActionListener(Container container) {
		container.addMouseListener(dragMouseListener);
		container.addMouseMotionListener(dragMouseMotionListener);
		container.addMouseListener(resizingMouseListener);
		container.addMouseMotionListener(resizingMouseMotionListener);
	}
	private boolean isResizedTime(MouseEvent me) {
		return me.getComponent().getCursor() == Cursor.getPredefinedCursor(Cursor.SE_RESIZE_CURSOR);
	}
	/**
	 * @return TitlebarPanel
	 */
	private JPanel getTitlebarPanel() {
		if(titlebarPanel == null){
			titlebarPanel = new JPanel(new BorderLayout());
			titlebarPanel.add(getTitleLabel(),BorderLayout.CENTER);
			titlebarPanel.add(getButtonsPanel(),BorderLayout.EAST);
			titlebarPanel.add(getPaddingPanel(),BorderLayout.WEST);
			titlebarPanel.setOpaque(false);
		}
		return titlebarPanel;
	}
	private JLabel getTitleLabel() {
		if(titleLabel == null){		
			titleLabel = new JLabel(super.getTitle());
			titleLabel.setHorizontalAlignment(JLabel.CENTER);
			titleLabel.setOpaque(false);
			titleLabel.addMouseListener(new MouseAdapter(){
				public void mousePressed(MouseEvent e) {
					dragMouseListener.mousePressed(e);
					if(!isFirstButton(e)){
						return;
					}
					if(e.getClickCount() == 2){
						setVisible(false);					
						pack();
						setVisible(true);
					}		
				}});
			titleLabel.addMouseMotionListener(dragMouseMotionListener);
		}
		return titleLabel;
	}
	/**
	 * @return PaddingPanel
	 */
	private JPanel getPaddingPanel() {
		JPanel temp = new JPanel();
		temp.setPreferredSize(getButtonsPanel().getPreferredSize());
		temp.setMinimumSize(getButtonsPanel().getMinimumSize());
		temp.setMaximumSize(getButtonsPanel().getMaximumSize());
		temp.setOpaque(false);
		return temp;
	}
	/**
	 * @return ButtonsPanel
	 */
	private JPanel getButtonsPanel() {	 
		if (buttonsPanel == null){
			buttonsPanel = new JPanel();
			buttonsPanel.add(getIconizingButton());
			buttonsPanel.add(getResizingButton());
			buttonsPanel.add(getClosingButton());
			buttonsPanel.setOpaque(false);
		}
		return buttonsPanel;
	}
	/**
	 * @return ClosingButton
	 */
	private Component getClosingButton() {
		JButton b = new JButton();
		b.setIcon(getClose());
		b.setRolloverIcon(getClose_Over());
		b.setPressedIcon(getClose_Press());
		b.setBorder(BorderFactory.createEmptyBorder());
		b.setOpaque(false);
		b.setFocusPainted(false);
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				fireCloseEvent();
			}});
		return b;
	}
	/**
	 * @return ResizingButton
	 */
	private Component getResizingButton() {
		JButton b = new JButton();
		b.setIcon(getResize());
		b.setRolloverIcon(getResize_Over());
		b.setPressedIcon(getResize_Press());
		b.setBorder(BorderFactory.createEmptyBorder());
		b.setOpaque(false);
		b.setFocusPainted(false);
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				fireFullSizeEvent();
			}});
		return b;
	}
	/**
	 * @return IconizingButton
	 */
	private Component getIconizingButton() {
		JButton button = new JButton();
		button.setIcon(getIconize());
		button.setRolloverIcon(getIconize_Over());
		button.setPressedIcon(getIconize_Press());
		button.setBorder(BorderFactory.createEmptyBorder());
		button.setOpaque(false);
		button.setFocusPainted(false);
		button.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				fireIconizeEvent();
			}});
		return button;
	}
	private void fireIconizeEvent(){
		this.setExtendedState(JFrame.ICONIFIED);
		WindowEvent we = new WindowEvent(this, WindowEvent.WINDOW_STATE_CHANGED);
		this.processWindowEvent(we);
		this.processWindowStateEvent(we);
	}
	private void fireCloseEvent(){
		WindowEvent we = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
		this.processWindowEvent(we);
	}
	private void fireFullSizeEvent(){
		if(this.getExtendedState() == JFrame.MAXIMIZED_BOTH ){
			this.setExtendedState(JFrame.NORMAL);
		}else{
			this.setExtendedState(JFrame.MAXIMIZED_BOTH);
		}
		WindowEvent we = new WindowEvent(this, WindowEvent.WINDOW_STATE_CHANGED);
		this.processWindowEvent(we);
		this.processWindowStateEvent(we);
	}
	public Container getContentPane() {
		return contentPanel;
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		if(this.isResizable()){
			g.drawImage(getCornerIcon().getImage(), this.getWidth() - getCornerIcon().getIconWidth()-5, this.getHeight()- getCornerIcon().getIconHeight()-5, this);
		}
	}
	public void setResizable(boolean b) {
		if(this.isResizable()&&!b){
			super.getContentPane().removeMouseListener(resizingMouseListener);
			super.getContentPane().removeMouseMotionListener(resizingMouseMotionListener);
		}else if(!this.isResizable()&& b){
			super.getContentPane().addMouseListener(resizingMouseListener);
			super.getContentPane().addMouseMotionListener(resizingMouseMotionListener);
		}
		super.setResizable(b);
	}
	/**
	 * @param object
	 */
	public void setUI(PanelUI ui) {
		this.panelUI = ui;
		getTitlebarPanel().setUI(ui);
		contentPanel.setUI(ui);
	}
	/**
	 * @param object
	 */
	public void setBorder(Border border) {
		((JPanel)super.getContentPane()).setBorder(border);
	}
	/* (non-Javadoc)
	 * @see javax.swing.JFrame#setJMenuBar(javax.swing.JMenuBar)
	 */
	public void setJMenuBar(JMenuBar menu) {		
		if( menuBar != null &&  menuBar.getParent() == getTitlebarPanel()){
			getTitlebarPanel().remove(menuBar);
		}
		menuBar = menu;
		if(menuBar != null){
			getTitlebarPanel().add(menuBar, BorderLayout.SOUTH);
		}
	}

	/* (non-Javadoc)
	 * @see javax.swing.JFrame#getJMenuBar()
	 */
	public JMenuBar getJMenuBar() {
		return menuBar;
	}

	/* (non-Javadoc)
	 * @see java.awt.Frame#setTitle(java.lang.String)
	 */
	public void setTitle(String title) {
		super.setTitle(title);
		getTitleLabel().setText(title);
	}



	/* (non-Javadoc)
	 * @see javax.swing.RootPaneContainer#setContentPane(java.awt.Container)
	 */
	public void setContentPane(Container contentPane) {
		this.contentPanel = (JPanel) contentPane;
	}

}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
