/*
 * Created on 2004. 1. 15.
 *
 */
package laf.mac;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.Window;
import java.util.Hashtable;

import javax.swing.ImageIcon;
import javax.swing.SwingUtilities;

import laf.mac.texturedUI.ComponentTexturer;

/**
 * @author hyoki
 *
 */
public class MetalTexturer implements ComponentTexturer {

	private static String fileLocation = "/icons/metalTexture";
	private static String buttonLocation = fileLocation+"/buttons";
	protected static ImageIcon texture = loadIcon(getFileLocation()+"/texture.gif");
	protected static ImageIcon dot = loadIcon(getFileLocation()+"/dot.gif");
	protected static ImageIcon corner = loadIcon(getFileLocation()+"/right_down_corner.gif");
	protected static ImageIcon lableBackground = loadIcon(getFileLocation()+"/textured_label.gif");

	protected static ImageIcon buttonBorder = loadIcon(buttonLocation+"/button_border.gif");
	protected static ImageIcon pressedBorder = loadIcon(buttonLocation+"/pressed_button_border.gif");
	
	protected static ImageIcon addButton = loadIcon(buttonLocation + "/add.gif");
	protected static ImageIcon addButtonSelect = loadIcon(buttonLocation + "/add.gif");
	protected static ImageIcon suffleButton = loadIcon(buttonLocation + "/shuffle_off.gif");
	protected static ImageIcon suffleButtonSelect = loadIcon(buttonLocation + "/shuffle_on.gif");
	protected static ImageIcon repeatButton = loadIcon(buttonLocation + "/repeat_off.gif");
	protected static ImageIcon repeatButtonSelect = loadIcon(buttonLocation + "/repeat_on.gif");
	protected static ImageIcon artworkButton = loadIcon(buttonLocation + "/cover_off.gif");
	protected static ImageIcon artworkButtonSelect = loadIcon(buttonLocation + "/cover_on.gif");

	protected static ImageIcon equalizerButton = loadIcon(buttonLocation+"/equalizer_off.gif");
	protected static ImageIcon equalizerButtonSelect = loadIcon(buttonLocation+"/equalizer_on.gif");
	protected static ImageIcon visualizerButton = loadIcon(buttonLocation+"/visualizer_off.gif");
	protected static ImageIcon visualizerButtonSelect = loadIcon(buttonLocation+"/visualizer_on.gif");
	protected static ImageIcon ejectButton = loadIcon(buttonLocation+"/media.gif");
	protected static ImageIcon ejectButtonSelect = loadIcon(buttonLocation+"/media_p.gif");
	

	private static ImageIcon loadIcon(String iconName) {
		return new ImageIcon(AquaRenderer.class.getResource(iconName));
//		return new ImageIcon(iconName);
	}
	
	private static Hashtable buttonTable = new Hashtable();
	static {
		buttonTable.put("addButton",addButton);
		buttonTable.put("addButtonSelect",addButtonSelect);
		buttonTable.put("suffleButton",suffleButton);
		buttonTable.put("suffleButtonSelect",suffleButtonSelect);
		buttonTable.put("repeatButton",repeatButton);
		buttonTable.put("repeatButtonSelect",repeatButtonSelect);
		buttonTable.put("artworkButton",artworkButton);
		buttonTable.put("artworkButtonSelect",artworkButtonSelect);
		
		buttonTable.put("equalizerButton",equalizerButton);
		buttonTable.put("equalizerButtonSelect",equalizerButtonSelect);
		buttonTable.put("visualizerButton",visualizerButton);
		buttonTable.put("visualizerButtonSelect",visualizerButtonSelect);
		buttonTable.put("ejectButton",ejectButton);
		buttonTable.put("ejectButtonSelect",ejectButtonSelect);
	}
	private  Image background = null;	
	public void paint(Graphics g, Component c){
		if (background == null) {
			background = getBackground(c, texture);
		}
		Window win = SwingUtilities.getWindowAncestor(c);
		Point point = SwingUtilities.convertPoint(c,0,0,win);
	
		g.drawImage(background, -(point.x), -(point.y), win.getWidth(),background.getHeight(c),c);
	}
	/**
	 * @param c
	 * @return
	 */
	private Image getBackground(Component c, ImageIcon imageIcon) {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Image bg = c.createImage(screenSize.width, screenSize.height);
		Graphics g = bg.getGraphics();
		int height = imageIcon.getIconHeight();
		int z=0;
		for(int y = 0; y < screenSize.height ; y +=(int)((1.0*z%8*5%12/12)*20)){
			g.drawImage(imageIcon.getImage(), (int)((1.0*z%11*5%13/12)*20)-20, y, screenSize.width+40, height, c);
			z=(z+1)%20;
		}
		return bg;
	}

	/* (non-Javadoc)
	 * @see laf.mac.metal.texturedUI.ComponentTexturer#paintSplitDot(java.awt.Graphics)
	 */
	public void paintSplitDot(Graphics g, Component divider) {
		g.drawImage(dot.getImage(), divider.getWidth()/2-1, divider.getHeight()/2-2, divider);
	}

	/* (non-Javadoc)
	 * @see laf.mac.metal.texturedUI.ComponentTexturer#getPreferredSplitWidth()
	 */
	public int getPreferredSplitThickness() {
		return 10;
	}
	/**
	 * @return
	 */
	public static String getFileLocation() {
		return fileLocation;
	}

	/**
	 * @param string
	 */
	public static void setFileLocation(String string) {
		fileLocation = string;
	}
	public void paintPressedBorder(Component c, Graphics g, int x, int y){
		g.drawImage(pressedBorder.getImage(),x,y,c);
	}
	public void paintUnpressedBorder(Component c, Graphics g, int x, int y){
		g.drawImage(buttonBorder.getImage(),x,y,c);
	}

	/* (non-Javadoc)
	 * @see laf.mac.renderedUI.ComponentRenderer#paint(java.awt.Graphics, javax.swing.JComponent)
	 */
	public void paintLable(Graphics g, Component c) {
		g.drawImage(lableBackground.getImage(),0,0,c.getWidth()+2,c.getHeight(),c);
	}
	/* (non-Javadoc)
	 * @see laf.mac.texturedUI.ComponentTexturer#getButtonTable()
	 */
	public Hashtable getButtonTable() {
		return buttonTable;		
	}
}
