/*
 * Created on 2004. 1. 17.
 *
 */
package laf.mac.renderedUI;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JSlider;

/**
 * @author hyoki
 *
 */
public interface ComponentRenderer {
	/**
	 * @param orientation
	 * @param 
	 * @return
	 */
	JButton createScrollButton(int orientation);
	/**
	 * @param graphics
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 * @param renderer
	 */
	void paintTableHeaderBG(Graphics g, JComponent columnHeader);
	/**
	 * @param graphics
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 * @param renderer
	 */
	void paintTableHeaderSelected(Graphics g, JComponent columnHeader);
	/**
	 * @param g
	 * @param c
	 * @param thumbBounds
	 */
	void paintVerticalThumb(Graphics g, JComponent c, Rectangle thumbBounds);
	/**
	 * @param g
	 * @param c
	 * @param thumbBounds
	 */
	void paintHorizontalThumb(Graphics g, JComponent c, Rectangle thumbBounds);
	/**
	 * @param g
	 * @param c
	 * @param trackBounds
	 */
	void paintVerticalTrack(Graphics g, JComponent c, Rectangle trackBounds);
	/**
	 * @param g
	 * @param c
	 * @param trackBounds
	 */
	void paintHorizontalTrack(Graphics g, JComponent c, Rectangle trackBounds);
	/**
	 * @return
	 */
	int getTableHeaderSize();
	/**
	 * @param string
	 * @return
	 */
	Color getColor(String string);
	/**
	 * @param g
	 * @param rectangle
	 */
	void paintSliderTrack(Graphics g, JSlider slider, Rectangle rectangle);
	/**
	 * @param g
	 * @param slider
	 * @param thumbRect
	 */
	void paintSliderThumb(Graphics g, JSlider slider, Rectangle thumbRect);
	/**
	 * 
	 */
	Hashtable getLabelTable();
	/**
	 * @return
	 */
	Hashtable getButtonTable();
	/**
	 * @param g
	 */
	void paintTextFieldBackground(Graphics g, JComponent c);
	/**
	 * @param g
	 * @param c
	 */
	void paint(Graphics g, JComponent c);
}
