/*
 * Created on 2004. 1. 17.
 *
 */
package laf.mac.renderedUI;

import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.SwingConstants;
import javax.swing.plaf.basic.BasicScrollBarUI;


/**
 * @author hyoki
 *
 */
public class RenderedScrollBarUI extends BasicScrollBarUI {
	private int directedType = SwingConstants.VERTICAL;
	/**
	 * @param renderer
	 * @param i
	 */
	public RenderedScrollBarUI(ComponentRenderer renderer, int i) {
		super();		
		this.renderer = renderer;
		this.directedType = i;		
	}
	private RenderedScrollBarUI(){}
	
	private ComponentRenderer renderer = null;

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicScrollBarUI#createDecreaseButton(int)
	 */
	protected JButton createDecreaseButton(int orientation) {
		return renderer.createScrollButton(orientation);
	}

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicScrollBarUI#createIncreaseButton(int)
	 */
	protected JButton createIncreaseButton(int orientation) {
		return renderer.createScrollButton(orientation);
	}

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicScrollBarUI#paintThumb(java.awt.Graphics, javax.swing.JComponent, java.awt.Rectangle)
	 */
	protected void paintThumb(
		Graphics g,
		JComponent c,
		Rectangle thumbBounds) {
			if(directedType == SwingConstants.VERTICAL){
				renderer.paintVerticalThumb(g, c, thumbBounds);
			}else if(directedType == SwingConstants.HORIZONTAL){
				renderer.paintHorizontalThumb(g, c, thumbBounds);
			}else{
				throw new UnsupportedOperationException();
			}
	}

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicScrollBarUI#paintTrack(java.awt.Graphics, javax.swing.JComponent, java.awt.Rectangle)
	 */
	protected void paintTrack(
		Graphics g,
		JComponent c,
		Rectangle trackBounds) {
			if(directedType == SwingConstants.VERTICAL){
				renderer.paintVerticalTrack(g, c, trackBounds);
			}else if(directedType == SwingConstants.HORIZONTAL){
				renderer.paintHorizontalTrack(g, c, trackBounds);
			}else{
				throw new UnsupportedOperationException();
			}
	}
}
