/*
 * Created on 2004. 1. 21.
 *
 */
package laf.mac.renderedUI;

import java.awt.Graphics;

import javax.swing.JSlider;
import javax.swing.plaf.basic.BasicSliderUI;

/**
 * @author hyoki
 *
 */
public class RenderedSliderUI extends BasicSliderUI {
	private ComponentRenderer renderer;
	private int direction = 0;
	/**
	 * @param slider
	 * @param renderer
	 */
	public RenderedSliderUI(JSlider slider, ComponentRenderer renderer) {
		this(slider);
		this.renderer = renderer;
	}

	/**
	 * @param b
	 */
	public RenderedSliderUI(JSlider b) {
		super(b);
	}
	

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicSliderUI#paintThumb(java.awt.Graphics)
	 */
	public void paintThumb(Graphics g) {
		renderer.paintSliderThumb(g, slider,thumbRect);		
	}

	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicSliderUI#paintTrack(java.awt.Graphics)
	 */
	public void paintTrack(Graphics g) {
		renderer.paintSliderTrack(g, slider, trackRect);
	}
	
	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicSliderUI#calculateThumbLocation()
	 */
	protected void calculateThumbLocation() {
		super.calculateThumbLocation();
		thumbRect.y = trackRect.y + thumbRect.height/4;
	}

}
