/*
 * Created on 2004. 1. 20.
 *
 */
package laf.mac.renderedUI;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;


/**
 * @author hyoki
 *
 */
public class RenderedTableCell extends DefaultTableCellRenderer {

	private ComponentRenderer renderer = null;
	private RenderedTableCell(){}
	/**
	 * @param renderer
	 */
	public RenderedTableCell(ComponentRenderer renderer) {
		this.renderer = renderer;
		this.setOpaque(true);
		this.evenBackground = renderer.getColor("evenBackground");
		this.oddBackground = renderer.getColor("oddBackground");
		this.selection = renderer.getColor("selection");
		this.foreground = renderer.getColor("forground");
		this.selectionForground = renderer.getColor("selectionForground");
	}
	private Color evenBackground = null;
	private Color oddBackground = null;
	private Color selection = null;
	private Color foreground = null;
	private Color selectionForground = null;

	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableCellRenderer#getTableCellRendererComponent(javax.swing.JTable, java.lang.Object, boolean, boolean, int, int)
	 */
	public Component getTableCellRendererComponent(
		JTable table,
		Object value,
		boolean isSelected,
		boolean hasFocus,
		int row,
		int column) {
		this.setForeground(foreground);	
		if(row%2 == 0) setBackground(oddBackground);
		else if(row%2 == 1) setBackground(evenBackground);
		if(isSelected){
			this.setForeground(selectionForground);
			this.setBackground(selection);			
		}
		// TODO ⿡ Song  ؼϴ κ ־Ѵ.
		
		this.setValue(value);
		return this;
	}

}
