/*
 * Created on 2004. 1. 17.
 *
 */
package laf.mac.texturedUI;

import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JSplitPane;
import javax.swing.plaf.basic.BasicSplitPaneDivider;
import javax.swing.plaf.basic.BasicSplitPaneUI;


/**
 * @author hyoki
 *
 */
public class TexturedSplitPaneUI extends BasicSplitPaneUI {
	private TexturedSplitPaneUI(){}
	/**
	 * @param texturer
	 */
	public TexturedSplitPaneUI(ComponentTexturer texturer) {
		this.texturer = texturer;
	}
	private ComponentTexturer texturer = null;
	
	/* (non-Javadoc)
	 * @see javax.swing.plaf.basic.BasicSplitPaneUI#createDefaultDivider()
	 */
	public BasicSplitPaneDivider createDefaultDivider() {
		return new BasicSplitPaneDivider(this){
			public void paint(Graphics g) {
				texturer.paint(g, this);
				texturer.paintSplitDot(g, this);
				super.paint(g);
			}
			public Dimension getPreferredSize() {
				if (orientation == JSplitPane.HORIZONTAL_SPLIT) {
					return new Dimension(getDividerSize(), texturer.getPreferredSplitThickness());
				}else if(orientation == JSplitPane.VERTICAL_SPLIT){
					return new Dimension(texturer.getPreferredSplitThickness(), getDividerSize());
				}
				throw new UnsupportedOperationException();
			}
		};
	}

}
