/*
 * Created on 2004. 1. 15.
 *
 */
package laf.mac.texturedUI;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.Border;

/**
 * @author hyoki
 *
 */
public class TexturedWindowBorder implements Border {

	/* (non-Javadoc)
	 * @see javax.swing.border.Border#isBorderOpaque()
	 */
	public boolean isBorderOpaque() {
		return true;
	}

	/* (non-Javadoc)
	 * @see javax.swing.border.Border#paintBorder(java.awt.Component, java.awt.Graphics, int, int, int, int)
	 */
	public void paintBorder(
		Component c,
		Graphics g,
		int x,
		int y,
		int width,
		int height) {
			width--;
			height--;
			Color oldColor = g.getColor();
			int radius = 3;
	
			over1(g, x, y, width, radius);
			over2(g, x, y, width, radius);
			left1(g, x, y, height, radius);
			left2(g, x, y, height, radius);
			right1(g, x, y, width, height, radius);
			right2(g, x, y, width, height, radius);
			under1(g, x, y, width, height, radius);
			under2(g, x, y, width, height, radius);
	
			g.setColor(oldColor);
	}
	private void over1(Graphics g, int x, int y, int width, int radius) {
		g.setColor(Color.gray);
		g.drawLine(x+radius, y, x+width-radius, y);
		g.drawLine(x+radius, y, x, y+radius);
		g.drawLine(x+width-radius, y, x+width, y+radius);
		
	}
	private void over2(Graphics g, int x, int y, int width, int radius) {
		g.setColor(Color.white);
		g.drawLine(x+radius,y+1, x+width-radius, y+1);
		g.drawLine(x+radius,y+1, x+1, y+radius);
		g.drawLine(x+width-radius,y+1, x+width-1, y+radius);
		
	}
	private void under2(
		Graphics g,
		int x,
		int y,
		int width,
		int height,
		int radius) {
		g.setColor(Color.gray);
		g.drawLine(x+radius,y+height-1, x+width-radius, y+height-1);
		g.drawLine(x+1,y+height-radius, x+radius,y+height-1);
		g.drawLine(x+width-1,y+height-radius, x+width-radius,y+height-1);
	}
	private void under1(
		Graphics g,
		int x,
		int y,
		int width,
		int height,
		int radius) {
		g.setColor(Color.darkGray);
		g.drawLine(x+radius, y+height, x+width-radius, y+height);
		g.drawLine(x,y+height-radius, x+radius,y+height);
		g.drawLine(x+width,y+height-radius, x+width-radius,y+height);
	}
	private void right2(
		Graphics g,
		int x,
		int y,
		int width,
		int height,
		int radius) {
		g.setColor(Color.gray);
		g.drawLine(x+width-1,y+radius,x+width-1,y+height-radius);
	}
	private void right1(
		Graphics g,
		int x,
		int y,
		int width,
		int height,
		int radius) {
		g.setColor(Color.lightGray);
		g.drawLine(x+width,y+radius,x+width,y+height-radius);
		
	}
	private void left2(Graphics g, int x, int y, int height, int radius) {
		g.setColor(Color.gray);
		g.drawLine(x+1,y+radius,x+1,y+height-radius);
		
	}
	private void left1(Graphics g, int x, int y, int height, int radius) {
		g.setColor(Color.lightGray);
		g.drawLine(x,y+radius,x,y+height-radius);
		
	}

	/* (non-Javadoc)
	 * @see javax.swing.border.Border#getBorderInsets(java.awt.Component)
	 */
	public Insets getBorderInsets(Component c) {
		return new Insets(2,2,2,2);
	}

}
