/*
 * Created on 2004. 2. 3.
 *
 */
package model;


import java.util.Vector;

import model.api.Library;
import model.api.LibraryChangeListener;
import model.api.Playlist;
import model.impl.LibraryManager;


/**
 * @author hyoki
 *
 */
public class LibraryModel extends javax.swing.table.AbstractTableModel implements LibraryChangeListener{
	
	/**
	 * @param libraryManager
	 */
	public LibraryModel(LibraryManager libraryManager) {
		super();
		libraryManager.addListener(this);
		addLibraries(libraryManager.getLibraries());
	}

	/**
	 * @param libraries
	 */
	private void addLibraries(Library[] libraries) {
		for (int i = 0; i < libraries.length; i++) {
			addPlaylists(libraries[i].getAllPlaylists());
		}		
	}

	private Library library = null;
	
	private int libararySize = 0;
	private int smartPlaylistSize = 0;
	private int playlistSize = 0;

	private void addPlaylists(Playlist[] list) {
		for (int i = 0; i < list.length; i++) {
			this.addPlaylist(list[i]);
		}
	}

	Vector items = new Vector();

	/**
	 * @param playlist
	 */
	private void addPlaylist(Playlist playlist) {
		if(playlist != null){
			if(playlist instanceof Library){
				items.add(libararySize, playlist);
				libararySize++;
			// TODO smartplayList will be implemented
			}else if(playlist.isSmartList()){
//				items.add(libararySize + smartPlaylistSize,playlist);
//				smartPlaylistSize++;
			}else if(!playlist.isSmartList()){
				items.add(libararySize+smartPlaylistSize+playlistSize,playlist);
				playlistSize++;
			}else{
				throw new UnsupportedOperationException();
			}
		}
	}
	/**
	 * @param i
	 * @return
	 */
	public Playlist getList(int index) {
		return ((Playlist)items.get(index));
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return 1;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return items.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int row, int arg1) {
		return ((Playlist)items.get(row)).getName();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnName(int)
	 */
	public String getColumnName(int column) {
		return "";
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#isCellEditable(int, int)
	 */
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return true;
	}

	/* (non-Javadoc)
	 * @see api.LibraryChangeListener#libraryRegistered(api.Library)
	 */
	public void libraryRegistered(Library library) {
		this.addPlaylist(library);
	}

	/* (non-Javadoc)
	 * @see api.LibraryChangeListener#libraryUnregistered(api.Library)
	 */
	public void libraryUnregistered(Library library) {
		this.items.remove(library);
	}

}
