/*
 * Created on 2004. 2. 3.
 *
 */
package model;


import java.util.Hashtable;

import model.api.Playlist;
import model.api.Song;

/**
 * @author hyoki
 *
 */
public class PlaylistModel extends javax.swing.table.AbstractTableModel {
	Hashtable columnHeader = new Hashtable();
	Playlist playlist = null;	
	/**
	 * @param playlist
	 */
	public PlaylistModel(Playlist playlist) {
		this.playlist = playlist;
		initialize();
	}

	/**
	 * 
	 */
	private void initialize() {
		columnHeader.put(new Integer(0),"Song Name");	
		columnHeader.put(new Integer(1),"Time");
		columnHeader.put(new Integer(2),"Artist");
		columnHeader.put(new Integer(3),"Album");
		columnHeader.put(new Integer(4),"Gerne");		
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return 5;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return playlist.getSongSize();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int rowIndex, int columnIndex) {
		switch (columnIndex) {
			case 0 :
				return playlist.getSong(rowIndex).getName();				
			case 1 :
				int displayTime = (int) (playlist.getSong(rowIndex).getTotalTime()/1000);
				return displayTime/60+":"+(displayTime%60<10?"0":"")+displayTime%60;			
				
			case 2 :
				return playlist.getSong(rowIndex).getArtist();
			case 3 :
				return playlist.getSong(rowIndex).getAlbum();
			case 4 :
				return playlist.getSong(rowIndex).getGenre();
			default :
			return null;
		}
	}

	/**
	 * @param i
	 */
	public Song getSong(int i) {
		return playlist.getSong(i);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnName(int)
	 */
	public String getColumnName(int column) {		
		return (String) columnHeader.get(new Integer(column));
	}

}
