package model.impl.local;

import helliker.id3.MP3File;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import model.api.Song;


/**
 * @author Jeong Ingu
 * 
 */
public class LocalFileSong implements Song {

	private int _id;
	private String _name;
	private String _artist;
	private String _album;
	private String _genre;
	private String _kind;
	private long _size;
	private long _totalTime;
	private int _trackNumber;
	private String _year;
	private int _bitRate;
	private int _sampleRate;
	private String _comments;
	private String _fileLocation;

	public LocalFileSong(String prevLocation, boolean fileCopy) {
		//TODO ʷ̼ ٹ   
		
		if (fileCopy) {
			mp3FileCopy(prevLocation);
		}
		
		fillContext(prevLocation);
		setFileLocation(prevLocation, fileCopy);
		 
	}
	private void mp3FileCopy(String prevLocation) {
			try {
				URL fileUrl = new URL(prevLocation);
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			File targetFile = new File(_fileLocation, getName());
			//TODO MP3 iTunes  ϱ
			//copy(fileUrl, targetFile);
	}

	private void setFileLocation(String location, boolean fileCopy) {
		if(fileCopy) {
			_fileLocation = LocalXMLLibrary._musicFolder + "/" + getArtist() + "/" + getAlbum() + "/" + getName();
		}else {
			_fileLocation = location;
		}
	}
	/**
	 * @param location
	 */
	private void fillContext(String location) {

		//File file = new File("c:/Documents and Settings/Administrator/My Documents/My Music/iTunes/iTunes Music/-.mp3");
		//ѱ 뷡 ȵǴ

		File file = new File(location);

		MP3File mp3;

		try {
			mp3 = new MP3File(file);
			
			setId();
			setName(mp3.getTitle());
			setArtist(mp3.getArtist());
			setAlbum(mp3.getAlbum());
			setGenre(mp3.getGenre());
			setSize(mp3.getFileSize());
			setTotalTime(mp3.getPlayingTime());
			setTrackNumber(mp3.getTrack());
			setYear(mp3.getYear());
			setBitRate(mp3.getBitRate());
			setSampleRate(mp3.getSampleRate());
			setComments(mp3.getComment());
			setFileLocation(location, false);

			System.out.println("getTitle()" + mp3.getTitle());
			System.out.println("getArtist()" + mp3.getArtist());
			System.out.println("getAlbum()" + mp3.getAlbum());
			System.out.println("getGenre()" + mp3.getGenre());
			System.out.println("getFileSize()" + mp3.getFileSize());
			System.out.println("getPlayingTime()" + mp3.getPlayingTime());
			System.out.println("getTrack()" + mp3.getTrack());
			System.out.println("getYear()" + mp3.getYear());
			System.out.println("getBitRate()" + mp3.getBitRate());
			System.out.println("getSampleRate()" + mp3.getSampleRate());
			System.out.println("getComment()" + mp3.getComment());
			System.out.println("location" + location);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	/**
	 * 
	 */
	private void setId() {
		
		_id = LocalXMLSong.getNextTrackId();
		
	}
	public int getId() {
		return _id;
	}
	public String getName() {

		return _artist;
	}
	public String getArtist() {

		return _artist;
	}
	public String getAlbum() {

		return _album;
	}
	public String getGenre() {
		return _genre;
	}
	public String getKind() {
		return _kind;
	}
	public long getSize() {
		return _size;
	}
	public long getTotalTime() {

		return _totalTime;
	}
	public int getTrackNumber() {
		return _trackNumber;
	}
	public String getYear() {
		return _year;
	}

	public int getBitRate() {

		return _bitRate;
	}
	public int getSampleRate() {

		return _sampleRate;
	}

	public String getComments() {

		return _comments;

	}

	public String getLocation() {

		return _fileLocation;
	}

	public InputStream getMusicStream() throws IOException {
		/*
		URL fileUrl = new URL(getLocation());
		return fileUrl.openStream();
		*/
		return null;
	}

	public void setAlbum(String string) {
		if (string == null) {
			_album = "UnknownAlbum";
		} else {
			_album = string;
		}
	}

	public void setArtist(String string) {
		if (string == null) {
			_artist = "UnknownArtist";
		} else {
			_artist = string;
		}
	}

	public void setBitRate(int i) {
		_bitRate = i;
	}

	public void setComments(String string) {
		_comments = string;
	}

	public void setGenre(String string) {
		_genre = string;
	}
	public void setId(int i) {
		_id = i;
	}

	public void setKind(String string) {
		_kind = string;
	}
	public void setName(String string) {
		_name = string;
	}

	public void setSampleRate(int i) {
		_sampleRate = i;
	}
	public void setSize(long l) {
		_size = l;
	}

	public void setTotalTime(long l) {
		_totalTime = l;
	}

	public void setTrackNumber(int i) {
		_trackNumber = i;
	}

	public void setYear(String string) {
		_year = string;
	}

	public String getModifiedDate() {
		return null;
	}
	public String getAddedDate() {
		return null;
	}
	public int getPlayCount() {
		return 0;
	}
	public long getPlayDate() {
		return 0;
	}
	public String getPlayDateUTC() {
		return null;
	}
	public int getRating() {
		return 0;
	}

}
