/*
 * Created on 2004. 2. 8.
 *
 */
package model.impl.remote;

import java.net.InetAddress;
import java.net.UnknownHostException;

import model.api.Library;
import daapLib.DaapServerInfoResponse;
import daapLib.DaapShared;
import daapLib.network.NetworkTransferThread;

/**
 * @author coms Administrator
 *
 */
public class RemoteFactory {

	private String hostname;

	private String password;
	private String sharedName;

	/**
	 * @param hostname
	 * @param string
	 */
	public RemoteFactory(String hostname, String password) {
		this.hostname = hostname;
		this.password = password;
		try {
			
			InetAddress addr = InetAddress.getByName(hostname);
			String adress = addr.getHostAddress();
			String ipA = addr.getCanonicalHostName();
			NetworkTransferThread network = new NetworkTransferThread(adress, "", "/server-info");
			network.start();
			while (network.isCompleted() == false) {
				Thread.sleep((int)(Math.random()*100));
			}						
			int httpStatus = network.getHTTPStatus();
			if (network.didAbort()) {
				// BUG v2  Ѵ.
				System.err.println("Host have not DAAP v1 Server");				
			}
			byte[] datas = network.getBuffer();

			DaapServerInfoResponse serverInfoResponse = new DaapServerInfoResponse(datas);
			sharedName = serverInfoResponse.getItemName();	
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}

	/**
	 * @return
	 */
	public Library getLibrary() {
		return new RemoteLibrary( new DaapShared(sharedName, hostname, null));
	}

}
