/*
 * Created on 2004. 2. 8.
 *
 */
package model.impl.remote;

import model.api.Library;
import model.api.Playlist;
import model.api.Song;
import daapLib.DaapPlaylist;
import daapLib.DaapShared;
import daapLib.api.DaapRemoteSong;
import daapLib.api.DaapRemoteSongs;

/**
 * @author coms Administrator
 *
 */
public class RemoteLibrary implements Library {

	private DaapShared shared = null;
	/**
	 * @param shared
	 */
	public RemoteLibrary(DaapShared shared) {
		this.shared = shared;
	}

	/* (non-Javadoc)
	 * @see api.Library#getPlaylist(int)
	 */
	public Playlist getPlaylist(int index) {
		return new RemotePlaylist((DaapPlaylist)shared.getChildAt(index));		
	}

	/* (non-Javadoc)
	 * @see api.Library#getAllPlaylists()
	 */
	public Playlist[] getAllPlaylists() {		
		int listCount = shared.getChildCount();
		Playlist[] playlists = new Playlist[listCount];
		for (int i = 0; i < listCount; i++) {
			playlists[i] = new RemotePlaylist((DaapPlaylist)shared.getChildAt(i));
		}			
		return playlists;
	}

	/* (non-Javadoc)
	 * @see api.Library#getPlaylistSize()
	 */
	public int getPlaylistSize() {		
		return shared.getChildCount();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#getAllSongs()
	 */
	public Song[] getAllSongs() {
		return convertSong(shared.getSongs());		
	}
	public static Song[] convertSong(DaapRemoteSongs remote) {
		Song[] songs = new Song[remote.getSongCount()];
		for (int i = 0; i < remote.getSongCount(); i++) {
			songs[i] = new RemoteSong(remote.getSongAtIndex(i));
		}
		return songs;
	}

	/* (non-Javadoc)
	 * @see api.Playlist#getSong(int)
	 */
	public Song getSong(int index) {
		DaapRemoteSong remoteSong = (DaapRemoteSong) shared.getSongs().getSongList().get(index);
//		DaapRemoteSong remoteSong = shared.getSongById(in)
		return new RemoteSong(remoteSong);		
	}

	/* (non-Javadoc)
	 * @see api.Playlist#getSongSize()
	 */
	public int getSongSize() {
		return shared.getSongs().getSongCount();
	}
	
	/* (non-Javadoc)
	 * @see api.Playlist#getName()
	 */
	public String getName() {
		return shared.getName();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#isSmartList()
	 */
	public boolean isSmartList() {
		return false;
	}
	/* (non-Javadoc)
	 * @see api.Library#getOwner()
	 */
	public String getOwner() {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Library#removePlaylist(api.Playlist)
	 */
	public void removePlaylist(Playlist list) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Library#createPlaylist(java.lang.String)
	 */
	public Playlist createPlaylist(String playlistName) {
		throw new UnsupportedOperationException();		
	}

	/* (non-Javadoc)
	 * @see api.Library#save()
	 */
	public void save() {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#addSong(api.Song)
	 */
	public void addSong(Song song) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#removeSong(int)
	 */
	public void removeSong(int index) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#setName(java.lang.String)
	 */
	public void setName(String name) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#setPlaylistId(int)
	 */
	public void setPlaylistId(int id) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#setPlaylistPersistentId(java.lang.String)
	 */
	public void setPlaylistPersistentId(String persistentId) {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#getPlaylistId()
	 */
	public int getPlaylistId() {
		throw new UnsupportedOperationException();
	}

	/* (non-Javadoc)
	 * @see api.Playlist#getPlaylistPersistentId()
	 */
	public String getPlaylistPersistentId() {
		throw new UnsupportedOperationException();
	}

}
