/*
 * Created on 2004. 2. 8.
 *
 */
package model.impl.remote;

import java.io.IOException;
import java.io.InputStream;

import model.api.Song;
import daapLib.api.DaapRemoteSong;


/**
 * @author coms Administrator
 *
 */
public class RemoteSong implements Song {

	private DaapRemoteSong song;

	/**
	 * @param song
	 */
	public RemoteSong(DaapRemoteSong song) {
		this.song = song;
	}

	/* (non-Javadoc)
	 * @see api.Song#getId()
	 */
	public int getId() {
		return song.getItemID();		
	}

	/* (non-Javadoc)
	 * @see api.Song#getName()
	 */
	public String getName() {
		return song.getItemName();
	}

	/* (non-Javadoc)
	 * @see api.Song#getArtist()
	 */
	public String getArtist() {
		return song.getArtist();
	}

	/* (non-Javadoc)
	 * @see api.Song#getAlbum()
	 */
	public String getAlbum() {
		return song.getAlbum();
	}

	/* (non-Javadoc)
	 * @see api.Song#getGenre()
	 */
	public String getGenre() {
		return song.getGenre();
	}

	/* (non-Javadoc)
	 * @see api.Song#getKind()
	 */
	public String getKind() {		
		return song.getFormat();
	}

	/* (non-Javadoc)
	 * @see api.Song#getSize()
	 */
	public long getSize() {
		return song.getSize();
	}

	/* (non-Javadoc)
	 * @see api.Song#getTotalTime()
	 */
	public long getTotalTime() {		
		return song.getTime();
	}

	/* (non-Javadoc)
	 * @see api.Song#getTrackNumber()
	 */
	public int getTrackNumber() {
		return song.getTrackNumber();
	}

	/* (non-Javadoc)
	 * @see api.Song#getYear()
	 */
	public String getYear() {
		return song.getYear()+"";
	}

	/* (non-Javadoc)
	 * @see api.Song#getModifiedDate()
	 */
	public String getModifiedDate() {
		return song.getDateModified();
	}

	/* (non-Javadoc)
	 * @see api.Song#getAddedDate()
	 */
	public String getAddedDate() {		
		return song.getDateAdded();
	}

	/* (non-Javadoc)
	 * @see api.Song#getBitRate()
	 */
	public int getBitRate() {		
		return song.getBitrate();
	}

	/* (non-Javadoc)
	 * @see api.Song#getSampleRate()
	 */
	public int getSampleRate() {
		return song.getSampleRate();
	}

	/* (non-Javadoc)
	 * @see api.Song#getComments()
	 */
	public String getComments() {		
		return song.getComment();
	}

	/* (non-Javadoc)
	 * @see api.Song#getPlayCount()
	 */
	public int getPlayCount() {		
		return 0;
	}

	/* (non-Javadoc)
	 * @see api.Song#getPlayDate()
	 */
	public long getPlayDate() {		
		return 0;
	}

	/* (non-Javadoc)
	 * @see api.Song#getPlayDateUTC()
	 */
	public String getPlayDateUTC() {		
		return null;
	}

	/* (non-Javadoc)
	 * @see api.Song#getRating()
	 */
	public int getRating() {		
		return 0;
	}

	/* (non-Javadoc)
	 * @see api.Song#getLocation()
	 */
	public String getLocation() {		
		return null;
	}

	/* (non-Javadoc)
	 * @see api.Song#getMusicStream()
	 */
	public InputStream getMusicStream() throws IOException {		
		return song.getStream();
	}

}
